//ICC-AVR application builder
// Target : M8
// Crystal: 6.0000Mhz

#include <iom8v.h>
#include <macros.h>
#include <eeprom.h>

typedef unsigned char 	U8;
typedef unsigned short  U16;
typedef unsigned long   U32;

#define TRUE  1
#define FALSE 0

//ӦϢ
#define ACK_SUCCESS       0x00
#define ACK_FAIL          0x01
#define ACK_FULL          0x04
#define ACK_NO_USER		  0x05
#define ACK_TIMEOUT       0x08

#define ACK_GO_OUT		  0x0F
//ûϢ
#define ACK_ALL_USER       0x00
#define ACK_GUEST_USER 	  0x01
#define ACK_NORMAL_USER 	  0x02
#define ACK_MASTER_USER    0x03

#define USER_MAX_CNT	   50

//
#define CMD_HEAD		  0xF5
#define CMD_TAIL		  0xF5
#define CMD_ADD_1  		  0x01
#define CMD_ADD_2 		  0x02
#define CMD_ADD_3	  	  0x03
#define CMD_MATCH		  0x0C
#define CMD_DEL			  0x04
#define CMD_DEL_ALL		  0x05
#define CMD_USER_CNT      0x09
#define CMD_LP_MODE		  0x2C

#define CMD_FINGER_DETECTED 0x14

#define Beep_Short		  45
#define Beep_Long		  230
#define Delay_Cap         300
#define Tout_Cnt		  5
#define Flash_Cnt         20

#define Flg_Add      	  0
		//ע־λ	  
#define Flg_Del 		  1
		//ɾ־λ
#define Flg_DelAll		  2
		//ȫɾ־λ
#define Flg_Door		  3
		//״̬־λ
#define Flg_Close		  4
		//״̬־λ
#define Flg_Open		  5
		//״̬־λ
#define Flg_Sleep 	  	  6
		//߱־λ
#define Flg_Interrupt 	  7
		//жϱ־λ

#define Key_Add			  0
		//עᰴ        PB
#define Key_Del			  1
		//ɾ        PB
#define Key_DelAll		  2
		//ȫɾ    PB
#define Sensor_Status     3
		//ɼͷ״̬	  PB
#define State_Close       4
		//״̬        PB
#define State_Open  	  5
		//״̬  	  PB
		
#define Wg_Data0		  0
		//Τ0       PC
#define Wg_Data1		  1
		//Τ1       PC
#define Ctrl_Speaker	  2
		//		  PC
#define Light_Green  	  3
		//̵			  PC
#define Light_Red		  4
		//			  PC
#define Power_5V		  5
		//5VԴ		  PC

#define Uart_Rx           0
		//UART        PD
#define Uart_Tx	  		  1		
		//UART		  PD
#define Reset_Dsp		  2
		//DSPλ		  PD
#define State_Door	  	  3
		//״̬		  PD
#define Power_Dsp		  4
		//DSPԴ		  PD
#define Ctrl_AD			  5
		//ѹ	  PD
#define Trans_Negative 	  6
		//ת	  PD
#define Trans_Positive 	  7
		//ת	  PD
		
//=========ȫֱ==========
U8 gRsBuf[9];				 //нջ
U8 gTxBuf[9];				 //зͻ
U8 gFlag, gFlagInput;
U8 gFlashRed, gFlashGreen;
U8 gIsLightOn;
U8 gSensorOn;
U8 gFlagInput;
U8 gKeyTemp1, gKeyTemp2;
U8 gTimer0Cnt;
U8 gRsLength;
U8 gDoorClosed;
U8 gDoorCloseEnable;
U8 gDoorCloseCnt;

void Delay100US()
{
 	 U16 i;
	 for (i = 85; i > 0; i--);
}
void DelayMS(U16 tim)         //1msʱ
{
	 U16 i;
	 while(tim > 0)
	 {
	  	 for(i = 856; i > 0; i--){;};
	  	 tim--;
      	 WDR(); //this prevents a timout on enabling
  	 }
}

//Light Red
void LightRedOff()
{
 	 PORTC |= BIT(Light_Red);
}
void LightRedOn()
{
 	 PORTC &= ~BIT(Light_Red);
}
void LightRedFlashOff()
{
 	 LightRedOff();
 	 gFlashRed = FALSE;
}
void LightRedFlashOn()
{
 	 gFlashRed = TRUE;
}
//Light Green
void LightGreenOff()
{
 	 PORTC |= BIT(Light_Green);
}
void LightGreenOn()
{
 	 PORTC &= ~BIT(Light_Green);
}
void LightGreenFlashOff()
{
 	 LightGreenOff();
 	 gFlashGreen = FALSE;	 
}
void LightGreenFlashOn()
{
 	 gFlashGreen = TRUE;
}
void ADCtrlOff()
{
 	 PORTD &= ~BIT(Ctrl_AD);
}
void ADCtrlOn()
{
 	 PORTD |= BIT(Ctrl_AD);
}
//Power 5V
void Power5VOff()
{
 	 PORTC &= ~BIT(Power_5V);
}
void Power5VOn()
{
 	 PORTC |= BIT(Power_5V);
}
//Power DSP
void PowerDspOff()
{
  	 PORTD &= ~BIT(Power_Dsp);
}
void PowerDspOn()
{
 	 PORTD |= BIT(Power_Dsp);
}
//Reset DSP
void ResetDspOn()
{
 	 PORTD &= ~BIT(Reset_Dsp); 
}
void ResetDspOff()
{
 	 PORTD |= BIT(Reset_Dsp);
} 
//Trans_Positive
void TransPositiveOff()
{
 	 PORTD |= BIT(Trans_Negative);
 	 PORTD |= BIT(Trans_Positive);
}
void TransPositiveOn()
{
 	 PORTD |= BIT(Trans_Negative);
 	 PORTD &= ~BIT(Trans_Positive);
}
//Trans_Negative
void TransNegativeOff()
{
 	 PORTD |= BIT(Trans_Positive);
 	 PORTD |= BIT(Trans_Negative);
}
void TransNegativeOn()
{
 	 PORTD |= BIT(Trans_Positive);
 	 PORTD &= ~BIT(Trans_Negative);
}
//Ctrl Speaker
void SpeakerOff()
{
 	 PORTC &=  ~BIT(Ctrl_Speaker);
}
void SpeakerOn()
{
 	 PORTC |=  BIT(Ctrl_Speaker);
}
void UartTxLow()
{	 
 	 PORTD &=  ~BIT(Uart_Tx);
}
void UartTxHigh()
{
 	 PORTD |=  BIT(Uart_Tx);
}
void SetUartTxInput()
{
 	 DDRD &= ~BIT(Uart_Tx);
}
void SetUartTxOutput()
{
 	 DDRD |= BIT(Uart_Tx);
}
void StateDoorPullUpOff()
{
 	 PORTD &= ~BIT(State_Door);
}
void StateDoorPullUpOn()
{
 	 PORTD |= BIT(State_Door);
}
void StateOpenPullUpOff()
{
 	 PORTB &= ~BIT(State_Open);
}
void StateOpenPullUpOn()
{
 	 PORTB |= BIT(State_Open);
}
void StateClosePullUpOff()
{
 	 PORTB &= ~BIT(State_Close);
}
void StateClosePullUpOn()
{
 	 PORTB |= BIT(State_Close);
}

void WgData0Out()
{
 	 PORTC &= ~BIT(Wg_Data0);
	 Delay100US();
	 PORTC |= BIT(Wg_Data0);
	 DelayMS(1);
}
void WgData1Out()
{
 	 PORTC &= ~BIT(Wg_Data1);
	 Delay100US();
	 PORTC |= BIT(Wg_Data1);
	 DelayMS(1);
}	
void WiegandOut(U8 FacCode, U16 IDNum)
{
 	char i;
	U8 tmp8;
	U16 tmp16;
  	U8 ChkEven, ChkOdd;
 	//λ1-λ12żУֵ
	ChkEven = 0;
	tmp8 = FacCode;
	for (i = 0; i < 8; i++)
	{
	 	if ((tmp8 & 0x80) != 0) ChkEven ^= 1;
		tmp8 <<= 1;
	}
	tmp16 = IDNum;
	for (i = 0; i < 4; i++)
	{
	 	if ((tmp16 & 0x8000) != 0) ChkEven ^= 1;
		tmp16 <<= 1;
	}		
	//λ13-λ24Уֵ
	ChkOdd = 1;
	for (i = 4; i < 16; i++)
	{
	 	if ((tmp16 & 0x8000) != 0) ChkOdd ^= 1;
		tmp16 <<= 1;
	}
	
	//ChkEven
	if (ChkEven == 0) WgData0Out();
	   			else  WgData1Out();
	//FacCode
	tmp8 = FacCode;
	for (i = 0; i < 8; i++)
	{
	 	if ((tmp8 & 0x80) == 0) WgData0Out();
		   			   	  else  WgData1Out();
		tmp8 <<= 1;
	}
	//IDNum
	tmp16 = IDNum;
	for (i = 0; i < 16; i++)
	{
	 	if ((tmp16 & 0x8000) == 0) WgData0Out();
		   		   	 	else  WgData1Out();
		tmp16 <<= 1;
	}
	//ChkOdd
	if (ChkOdd == 0) WgData0Out();
	   		   else  WgData1Out();
}
/******************ӳvoid Buzzer(U16 tim)**********************/
/*ܣһʱ***************************************************/
/*к***********************************************************/
/*ֵ*****************************************************************/
void Buzzer(U16 tim, U8 cnt)          //
{
 	 U8 i;
	 for (i = 0; i < cnt; i++)
	 {
	  	 SpeakerOn();
	 	 DelayMS(tim);
	 	 SpeakerOff();
		 DelayMS(tim);
	 }
}
U8 IsSensorOn()
{
   	 if ((PINB & 8) != 0)//BIT(Sensor_Status)
	 {
	  	 return TRUE;
	 }
	 else
	 {
	     return FALSE;
	 }
}
U8 IsDoorClosed()
{
     if ((PIND & BIT(State_Door)) == 0)
	 {
	  	 return TRUE;
	 }
	 else
	 {
	  	 return FALSE;
	 }
}
U8 IsStateOpen()
{
   	 if ((PINB & BIT(State_Open)) == 0)
	 {
	  	 return TRUE;
	 }
	 else
	 {
	  	 return FALSE;
	 }
}
U8 IsStateClose()
{
   	 if ((PINB & BIT(State_Close)) != 0)
	 {
	  	 return TRUE;
	 }
	 else
	 {
	  	 return FALSE;
	 }
}

U8 DoorOpenProcess()
{
 	 U8 i;
	 
	 if (IsStateOpen() == TRUE) return TRUE;
	 
	 TransPositiveOn();
	 for (i = 0; i < 10; i++)
	 {
	  	 if (IsStateOpen() == TRUE) break;
		 DelayMS (100);
	 }
	 TransPositiveOff();
	 DelayMS (50);
	 	 
	 if (i < 100) return TRUE;
	 	   	 else return FALSE;
}
U8 DoorCloseProcess()
{
 	 U8 i;
	 
	 if (IsStateClose() == TRUE) return TRUE;
	
	 SpeakerOn();
	 TransNegativeOn();
	 for (i = 0; i < 10; i++)
	 {
	  	 if (IsStateClose() == TRUE) break;
		 DelayMS (100);
	 }
	 TransNegativeOff();
	 SpeakerOff();
	 
	 DelayMS (50);
	 
	 if (i < 100) return TRUE;
	 	   	 else return FALSE;
}

void TxByte(U8 byte)
{
 	 UDR = byte;
 	 while (!(UCSRA & 0x40));//ѯͽ
	 UCSRA |= 0x40;	  		//ͽ־
}

U8 IsValidUser(U8 UserRole)
{
     if ((UserRole == 1) || (UserRole == 2) || (UserRole == 3)) return TRUE;
	 			  	   	  		   	  	   			 	   else return FALSE;
}

U8 IsMasterUser(U8 UserID)
{
     if ((UserID == 1) || (UserID == 2) || (UserID == 3)) return TRUE;
	 			   	 		   	  	   		  	    else  return FALSE;
}	 


/******************ڷӳbit SendUART(U8 Scnt,U8 Rcnt,U8 Delay)******/
/*ܣDSP********************************************************/
/*ScntֽRcntֽ Delayʱȴ*********************/
/*ֵTRUE ɹFALSE ʧ*******************************************************/
U8 TxAndRsCmd(U8 Scnt, U8 Rcnt, U8 Delay)
{

   	 U8  i, j, CheckSum;
	 U8  bCatchOn;
	 U32 RsTimeCnt;
	 
	 TxByte(CMD_HEAD);		//־ͷ
	 
	 CheckSum = 0;
	 for (i = 0; i < Scnt; i++)
	 {
	  	 TxByte(gTxBuf[i]);		 
		 CheckSum ^= gTxBuf[i];
	 }
	
	 TxByte(CheckSum);
	 TxByte(CMD_TAIL);
	  
	 gRsLength = 0;
	 RsTimeCnt = Delay * 120000;
	 
	 bCatchOn = FALSE;
	 while (gRsLength < Rcnt && RsTimeCnt > 0)
	 {
	    WDR();
		RsTimeCnt--;
		   
		if (gFlagInput == 1)
		{
		  	if ((gFlag & BIT(Key_Add)) != 0) break;
			if ((gFlag & BIT(Key_Del)) != 0) break;
			if ((gFlag & BIT(Key_DelAll)) != 0) break;
	//		if ((gFlag & BIT(State_Door)) != 0) break;
		}
		//bCatchOn½
		if (IsSensorOn() == TRUE)
		{
		    bCatchOn = TRUE;
		}
		else if (bCatchOn == TRUE)
		{
		    bCatchOn = FALSE;
			Buzzer(Beep_Short, 1);
		}
	 }
	 if (gFlagInput == 1) return ACK_GO_OUT;
	 if (gRsLength != Rcnt)return ACK_TIMEOUT;
	 if (gRsBuf[0] != CMD_HEAD) return ACK_FAIL;
	 if (gRsBuf[Rcnt - 1] != CMD_TAIL) return ACK_FAIL;
	 if (gRsBuf[1] != (gTxBuf[0])) return ACK_FAIL;
	 
	 CheckSum = 0;
	 for (j = 1; j < gRsLength - 1; j++) CheckSum ^= gRsBuf[j];
	 if (CheckSum != 0) return ACK_FAIL;
	  
	 gSensorOn = FALSE;	 
	 return ACK_SUCCESS;
}	 
/******************ָƱȶӳU8 CompFinger(void)*************************/
/*ܣɼָָƱȶ,ʽΪ1N ***********************************/
/* ******************************************************************/
/*ֵTRUEɹFALSEʧ*******************************************/
U8 CompFinger(U8 Total)
{
   	 U8 m;
	 
	 gTxBuf[0] = CMD_MATCH;
	 gTxBuf[1] = 0;
	 gTxBuf[2] = 0;
	 gTxBuf[3] = 0;
	 gTxBuf[4] = 0;	 
	  	 
	 LightGreenFlashOn();		 //̵˸
	 
	 m = TxAndRsCmd(5, 8, Tout_Cnt);
//	 Buzzer(Beep_Short, 1);
	 LightGreenFlashOff();
	 
	 DelayMS(500);
	  
	 if (m == ACK_TIMEOUT)
	 {	  	  
	    return ACK_TIMEOUT;
	 }
	 else if (m == ACK_GO_OUT)
	 {
	  	  return ACK_GO_OUT;
	 }
	 else if (Total == 0)
	 {
	  	  return ACK_SUCCESS;
	 }		 
	 else if ((m == ACK_SUCCESS) && (gRsBuf[3] != 0) && (IsValidUser(gRsBuf[4]) == TRUE))
	 {	  	  
	  	  LightGreenOn();	 //̵˸
		  Buzzer(Beep_Short, 3);		 //ѵѵѡ
		  LightGreenOff();
		   
	  	  return ACK_SUCCESS;
	 }
	 else
	 {
	      
	  	  if (gFlagInput != 1)
		  {
		      LightRedOn();		   //Ƴ
		  
		  	  Buzzer(Beep_Long, 3);//ѵѵѡ
		  		  
		  	  LightRedOff();
		  }
		  
	  	  return ACK_FAIL;
	 }  
}

/******************ԱȷӳU8 VerityManager(void)********************/
/*ܣɼָָƱȶ,ʽΪ1N ***********************************/
/* ******************************************************************/
/*ֵTRUE ɹFALSEʧ*******************************************************/
U8 VerifyManager(U8 Total, U8 Option)
{
    U8 m;
	
	gTxBuf[0] = CMD_MATCH;
	gTxBuf[1] = 0;
	gTxBuf[2] = 0;
	gTxBuf[3] = 0;
	gTxBuf[4] = 0;
	
	LightRedFlashOn();		//˸
	LightGreenFlashOn();	//̵˸
	Buzzer(Beep_Short, 1);
	
	m = ACK_SUCCESS;
	if (Total > 0)
	{
	    m = TxAndRsCmd(5, 8, Tout_Cnt);
	}

	LightRedFlashOff();
	LightGreenFlashOff();
	
	if (m == ACK_TIMEOUT) 
	{
	    return ACK_TIMEOUT;
	}
	else if (m == ACK_GO_OUT)
	{
	 	return ACK_GO_OUT;
	}
	else if ((m == ACK_SUCCESS) && (IsMasterUser(gRsBuf[3]) == TRUE))
	{	
		 LightGreenOn();   
	   	 Buzzer(Beep_Short, 3); //ѵѵѡ
		 LightGreenOff();
		 return ACK_SUCCESS;
	}
	else
	{
	 	 LightRedOn();			 //
		 if (Option == 1)//û֤
		 {
	 	  	  Buzzer(Beep_Long, 1);   //ѡһ
		 }
		 else if (Option == 2)//ɾû֤
		 {
		  	  Buzzer(Beep_Long, 1);   //ѵѵѡ
		 }
		 else if (Option == 3)//ɾԱ֤
		 {
		  	  Buzzer(Beep_Long, 1);  //ѡһ
		 }
	
		 LightRedOff();
		 
		 return ACK_FAIL;
	}
}
		 
/******************ָƴ洢ӳ**********************/
/*ܣ洢ûָ ********************************************************/
/*k ûָƴ洢**************************************************/
/*ֵTRUEɹFALSEʧ**************************/
U8 AddUser(U8 k)
{
   	U8 m;
	
	DelayMS (50);
	
	gTxBuf[0] = CMD_ADD_1;
	gTxBuf[1] = 0;
	gTxBuf[2] = k;
	gTxBuf[3] = 3;
	gTxBuf[4] = 0;	
	LightGreenFlashOn();
	
	m = TxAndRsCmd(5, 8, Tout_Cnt);
	
//	Buzzer(Beep_Short, 1);
	

	LightGreenFlashOff();
	
	DelayMS(Delay_Cap);
	
	if (m == ACK_TIMEOUT)
	{
	    return ACK_TIMEOUT;
	}
	else if (m == ACK_GO_OUT)
	{
	 	return ACK_GO_OUT;
	}
	else if (m == ACK_SUCCESS && gRsBuf[4] == ACK_SUCCESS)
	{
	   	 LightGreenFlashOn();  //̵˸
//		 Buzzer(Beep_Short, 1);//ѡһ
		 
		 gTxBuf[0] = CMD_ADD_2;
		 
		 m = TxAndRsCmd(5, 8, Tout_Cnt);
		 
//		 Buzzer(Beep_Short, 1);
		 LightGreenFlashOff();
		 
		 DelayMS(Delay_Cap);
		 
		 if (m == ACK_TIMEOUT)
		 {
		     return ACK_TIMEOUT;	 
		 }
		 else if (m == ACK_GO_OUT)
		 {
	 	  	 return ACK_GO_OUT;
		 }
		 else if (m == ACK_SUCCESS && gRsBuf[4] == ACK_SUCCESS)
		 {
	   	  	 LightGreenFlashOn();  //̵˸
//		 	 Buzzer(Beep_Short, 1);//ѡһ		 	 
	 
		 	 gTxBuf[0] = CMD_ADD_3;
			
			 m = TxAndRsCmd(5, 8, Tout_Cnt);
			 
//			 Buzzer(Beep_Short, 1);
			 LightGreenFlashOff();
			 
			 DelayMS(Delay_Cap);
			 DelayMS(Delay_Cap);
		 
		 	 if (m == ACK_TIMEOUT)
			 {
			     return ACK_TIMEOUT;
			 }
			 else if (m == ACK_GO_OUT)
			 {
	 		  	 return ACK_GO_OUT;
			 }
		 	 else if (m == ACK_SUCCESS && gRsBuf[4] == ACK_SUCCESS)
		 	 { 
			   	 LightGreenOn();
				 Buzzer(Beep_Short, 3);	//ѵѵѡ
				 LightGreenOff();
				 
				 return ACK_SUCCESS;
			 }
		 }
 	}
	//ʧ
	LightRedOn();
	Buzzer(Beep_Long, 3);//ѵѵѡ
	LightRedOff();
	return ACK_FAIL;
}

/******************ѯûӳ******************/
/*ܣѯû ********************************************************/
/*  *******************************************************************/
/*ֵû 0xFF:ʧ****************************************************************/
U8 GetUserCount()
{
   	U8 m;
	
	gTxBuf[0] = CMD_USER_CNT;
	gTxBuf[1] = 0;
	gTxBuf[2] = 0;
	gTxBuf[3] = 0;
	gTxBuf[4] = 0;	
	
	m = TxAndRsCmd(5, 8, 1);
		
	if (m == ACK_SUCCESS && gRsBuf[4] == ACK_SUCCESS)
	{
	    return gRsBuf[3];
	}
	else
	{
	 	return 0xFF;
	}
}

void ClearAllUser()
{
 	U8 m;
	
	gTxBuf[0] = CMD_DEL_ALL;
	gTxBuf[1] = 0;
	gTxBuf[2] = 0;
	gTxBuf[3] = 0;
	gTxBuf[4] = 0;
	
	m = TxAndRsCmd(5, 8, 5);
	
	if (m == ACK_SUCCESS && gRsBuf[4] == ACK_SUCCESS)
	{	    
		LightGreenOn();
		Buzzer(300, 1);
		LightGreenOff();		
	}
	else
	{
	 	LightRedOn();
		Buzzer(300, 1);
		LightRedOff();
	}
}
/******************ͨûӳ*******************/
/*ܣ ɾͨû********************************************************/
/* cntû *******************************************************************/
/*ֵTRUE ɹ FALSEʧ ******************************************************/
U8 ClearCommonUser(U8 cnt)
{
    U8 i, m;
	
	gTxBuf[0] = CMD_DEL;
	gTxBuf[1] = 0;
	gTxBuf[2] = 0;
	gTxBuf[3] = 0;
	gTxBuf[4] = 0;
	
	Buzzer(Beep_Long, 3);		//ѵѵѡ
	
	for (i = 4; i <= USER_MAX_CNT; i++)
	{
	 	gTxBuf[2] = i;
	
		m = TxAndRsCmd(5, 8, 2);
		DelayMS(20);
	
		if (m != ACK_SUCCESS || gRsBuf[4] != ACK_SUCCESS) break;		
	}
	if (i > cnt)//ɹ
	{
		Buzzer(Beep_Short, 3); 	 //ѵѵѡ
		return ACK_SUCCESS;
	}
	else
	{
	 	return ACK_SUCCESS;
	}
}	

/******************Աӳ*******************/
/*ܣ ɾԱû********************************************************/
/* cntû *******************************************************************/
/*ֵTRUE ɹ FALSEʧ ******************************************************/
U8 ClearManager(U8 cnt)
{
    U8 i, m;
	
	gTxBuf[0] = CMD_DEL_ALL;
	gTxBuf[1] = 0;
	gTxBuf[2] = 0;
	gTxBuf[3] = 0;
	gTxBuf[4] = 0;
	
	Buzzer(Beep_Long, 3);		//ѵѵѡ
	
	m = TxAndRsCmd(5, 8, 2);
	DelayMS(20);
	
	Buzzer(Beep_Short, 3); 	 //ѵѵѡ
/*	if (cnt <= 3)
	{
	    for (i = 1; i <= cnt; i++)
	    {
	 	    gTxBuf[2] = i;
		
		    m = TxAndRsCmd(5, 8, 2);
		    DelayMS(10);
		
		    if (m != ACK_SUCCESS || gRsBuf[4] != ACK_SUCCESS) break;
		}		
		if (i > cnt)//ɹ
		{
		    Buzzer(Beep_Short, 3); 	 //ѵѵѡ
			LightGreenFlashOff();

			return ACK_SUCCESS;
		}
	}
*/	
	return ACK_SUCCESS;
}

U8 NormalProcess()
{
    U8 m, Total;
		
	Total = GetUserCount();	
	if (Total == 0xFF) return 0xFF;
	
	Buzzer(Beep_Short, 1);				 //ѡһ
	
	while (1)
	{
	 	m = CompFinger(Total);
		
		if (m == ACK_TIMEOUT)
		{		   	 
		    return ACK_TIMEOUT;
		}
		else if (m == ACK_GO_OUT)
		{
		 	return ACK_GO_OUT;
		}
		else if (m == ACK_SUCCESS || gFlagInput == 1)
		{
		    break;
		}
	}
	
	if (m == ACK_SUCCESS)
	{
	 	if (Total != 0) WiegandOut (1, (U16)gRsBuf[3]);
	   
	    return ACK_SUCCESS;
	}	
	else
	{
	    return ACK_FAIL;
	}
}	
	
U8 KeyProcess()
{
 	U8 i, m, Total;
	U8 Flag1;

	Flag1 = gFlag;
	gFlag &= ~BIT(Flg_Add);
   	gFlag &= ~BIT(Flg_Del);
   	gFlag &= ~BIT(Flg_DelAll);
//	gFlag &= ~BIT(Flg_Door);

	gFlagInput = 0;
	if ((Flag1 & BIT(Key_Add)) != 0)
	{
	    	    
		Total = GetUserCount();
 		
//	 	if (Total == 0xFF);
		
		m = ACK_SUCCESS;
		while (1)
		{
		 	if (Total > 0)
			{
		        m = VerifyManager(Total, 1);
				if (m == ACK_TIMEOUT)
				{
			         return ACK_TIMEOUT;
				}
				else if (m == ACK_GO_OUT)
				{
	 			 	 return ACK_GO_OUT;
		    	}
				if (m == ACK_SUCCESS || gFlagInput == 1)
				{
			       	 break;
				}
			}
			else
			{
			 	//һ
	    		LightRedOn();
	    		LightGreenOn();		
				Buzzer(Beep_Short, 1);
				DelayMS(300);
				LightRedOff();
				LightGreenOff();
				break;
			}
		}
		if (m == ACK_SUCCESS)
		{
		    while (Total < USER_MAX_CNT)
			{		 	
		 		m = AddUser(Total + 1);				
				if (m == ACK_TIMEOUT)
				{
				    return ACK_TIMEOUT;
				}
				else if (m == ACK_GO_OUT)
				{
	 				return ACK_GO_OUT;
			    }			
				if (gFlagInput == 1)
				{
			        break;
				}
				Total = GetUserCount();
			}
		}
		return ACK_GO_OUT;
	}
	else if ((Flag1 & BIT(Key_Del)) != 0)
	{
		Total = GetUserCount();		
//		if (Total == 0xFF);
		while (1)
		{
		 	m = VerifyManager(Total, 2);
			
			if (m == ACK_TIMEOUT)
			{
			    return ACK_TIMEOUT;
			}
			else if (m == ACK_GO_OUT)
			{
	 		 	return ACK_GO_OUT;
			}
			if (m == ACK_SUCCESS || Total == 0 || gFlagInput == 1)
			{
			    break;
			}
		}
		ClearCommonUser(Total);			
		
		Total = GetUserCount();		
//		if (Total == 0xFF);		
		while (1)
		{
		 	m = VerifyManager(Total, 3);
			if (m == ACK_TIMEOUT)
			{
			    return ACK_TIMEOUT;
			}
			else if (m == ACK_GO_OUT)
			{
	 		 	return ACK_GO_OUT;
			}
			else if (m == ACK_SUCCESS || Total == 0)
			{
		        break;
			}
		}
		ClearManager(Total);
		
		return ACK_TIMEOUT;//
	}
	else if ((Flag1 & BIT(Key_DelAll)) != 0)
	{
	 	ClearAllUser();
		
		return ACK_TIMEOUT;// 
	}	
	else
	{	
	 	return ACK_TIMEOUT;//
	}		
}
//=========ʼ===========
void Rst_Dsp()       //DSPλ
{
// 	UartTxLow();
    ResetDspOn();//PORTD &=~ BIT(Ctr_Dsp_Reset);                       //DSPλ
	DelayMS(40);
	ResetDspOff();//PORTD |=  BIT(Ctr_Dsp_Reset);	
	DelayMS(90);
//	UartTxHigh();
	DelayMS(120);
}

void Init_Port()      //˿ڳʼ
{
 	PORTB = 0xFF;
 	DDRB  = 0x00;
 	PORTC = 0x5B; //m103 output only
 	DDRC  = 0x3F;
 	PORTD = 0xDF;//0xFF;
 	DDRD  = 0xF6;
}

//UART0 initialisation
// desired baud rate: 19200
// actual: baud rate:18750 (2.4%)
// char size: 8 bit
// parity: Disabled
void Init_Uart0(void)         //ڳʼ
{
 	SPCR  = 0x00; //set SPI status
 	UCSRB = 0x00; //disable while setting baud rate
 	UCSRA = 0x00;
 	UCSRC = 0x86;
 	UBRRL = 0x13; //set baud rate lo
 	UBRRH = 0x00; //set baud rate hi
 	UCSRB = 0x98;
}

//TIMER0 initialisation - prescale:256
// WGM: Normal
// desired value: 10mSec
// actual value:  9.984mSec (0.2%)
void Init_Timer0()      //ʱ0ʼ?
{
 	TCCR0 = 0x00; //stop
 	TCNT0 = 0x16; //set count
 	TCCR0 = 0x04; //start timer	
}
#pragma interrupt_handler timer0_ovf_isr:10
void timer0_ovf_isr()    // ʱ0ʼ10msʱ
{
 	TCNT0 = 0x16; //reload counter value
 	gKeyTemp1 = (PINB | 0xF8);
	
 	if (gKeyTemp1 != 0xFF)
 	{
  	 	if (gKeyTemp1 == gKeyTemp2)
  		{
   		 	if((gKeyTemp1 | 0xFE) == 0xFE) gFlag |= BIT(Flg_Add);  //עᰴ
			if((gKeyTemp1 | 0xFD) == 0xFD) gFlag |= BIT(Flg_Del);   //ɾ
			if((gKeyTemp1 | 0xFB) == 0xFB) gFlag |= BIT(Flg_DelAll);//ȫɾ
			//if((gKeyTemp1 | 0xF7) == 0xF7) gFlag |= BIT(Flg_Door);  //״̬
  			//if((gKeyTemp1 | 0xEF) == 0xEF) gFlag |= BIT(Flg_Close); //ŵλ
   			//if((gKeyTemp1 | 0xDF) == 0xDF) gFlag |= BIT(Flg_Open);  //ŵλ
			
			
			gFlagInput = 1;			
  		}
 	}
 	gKeyTemp2 = gKeyTemp1;
	
	if (gTimer0Cnt == 0)
	{
	    if (gFlashRed == TRUE)
		{
            if (IsSensorOn() == TRUE)
			{
			    if (gIsLightOn == TRUE)
			    {		   
		            LightRedOn();
				}
			    else
			    {
			        LightRedOff();
				}
			}
			else
			{
			 	LightRedOff();
			}
		}
		if (gFlashGreen == TRUE)
		{
            if (IsSensorOn() == TRUE)
			{
			    if (gIsLightOn == TRUE)
			    {		   
		            LightGreenOn();
				}
			    else
			    {
			        LightGreenOff();
				}
			}
			else
			{
			 	LightGreenOff();
			}
		}	
		
		if (gIsLightOn == TRUE) gIsLightOn = FALSE;
		   			   	  else  gIsLightOn = TRUE;
	}
	//״̬ж
	if (gDoorCloseEnable == TRUE)
	{
	   	if (IsDoorClosed () == TRUE)
		{
	       	if (IsStateClose () == FALSE)
			{
			    gDoorCloseCnt ++;
				if (gDoorCloseCnt >= 80)
				{
	       	   	   	gDoorClosed = FALSE;
	       		   	SpeakerOn();
	   	   			TransNegativeOn();
				}
			}
			else 
			{
			 	gDoorCloseCnt = 0;
			}
		}
		else
		{
		 	gDoorCloseCnt = 0;
		}
		if (IsStateClose () == TRUE)
		{
	   	   	if (gDoorClosed == FALSE)
	   		{
	      	   gDoorClosed = TRUE;
		  	   SpeakerOff();
		  	   TransNegativeOff();
	   		}
		}
	}
	
	gTimer0Cnt++;
	if (gTimer0Cnt > Flash_Cnt) gTimer0Cnt = 0;	
}

//TIMER1 initialisation - prescale:1024
// WGM: 0) Normal, TOP=0xFFFF
// desired value: 1Sec
// actual value:  1.000Sec (0.0%)
void Init_Timer1()        //ʱ1ʼ
{
  	TCCR1B = 0x00; //stop
 	TCNT1H = 0xE9; //setup
 	TCNT1L = 0x1D;
 	OCR1AH = 0x16;
	OCR1AL = 0xE3;
	OCR1BH = 0x16;
 	OCR1BL = 0xE3;
 	ICR1H  = 0x16;
 	ICR1L  = 0xE3;
 	TCCR1A = 0x00;
 	TCCR1B = 0x05; //start Timer
}
#pragma interrupt_handler int1_isr:3
void int1_isr(void)
{
}

#pragma interrupt_handler timer1_ovf_isr:9
void timer1_ovf_isr(void)      //ʱ1жϷ
{
 	//TIMER1 has overflowed
 	TCNT1H = 0xE9; //reload counter high value
 	TCNT1L = 0x1D; //reload counter low value
}

void Uart0_Init()
{
 	UCSRB = 0x00; //disable while setting baud rate
 	UCSRA = 0x00;
 	UCSRC = 0x86;
 	UBRRL = 0x13; //set baud rate lo
 	UBRRH = 0x00; //set baud rate hi
 	UCSRB = 0x98;
}

#pragma interrupt_handler uart0_rx_isr:12
void uart0_rx_isr(void)     //жϷ
{
  	unsigned char temp,temp1;
  	CLI();
//  if(UDR==0xAA) gRsLength=0;LUU
  	gRsBuf[gRsLength++] = UDR;
  	SEI();
}

//call this routine to initialise all peripherals
void Init_Devices()        //豸ʼ
{
 	//stop errant interrupts until set up
 	CLI(); //disable all interrupts
 	Init_Port();
	
	gTimer0Cnt = 0;
	gKeyTemp1 = 0xFF;
	gKeyTemp2 = 0xFF;
	gFlag = 0;
	gSensorOn = FALSE;
	
// watchdog_init();//ʼŹ
   	Init_Uart0();
   	Init_Timer0();
   	Init_Timer1();
   	MCUCR = 0x00;
   	GICR  = 0x00;
   	TIMSK = 0x05; //timer interrupt sources
   	SEI(); //re-enable interrupts
   	//all peripherals are now initialised
	
	LightRedOff();
	LightGreenOff();
	LightRedFlashOff();
	LightGreenFlashOff();
	gIsLightOn = TRUE;	
	gDoorClosed = TRUE;
	gDoorCloseCnt = 0;
	gDoorCloseEnable = TRUE;
	
}

void Sleep_Board(U8 bPullUpOn)
{	
 	//close all IOs
	PORTB = 0;
	PORTC = 0;
	PORTD = 0;
	//disable UART
	UCSRB = 0;
	
	LightRedOff();
	LightGreenOff();
	if (bPullUpOn == TRUE)
	{
	    StateDoorPullUpOn();
	}
	else
	{
	 	StateDoorPullUpOff();	    
	}
	StateOpenPullUpOff();
	StateClosePullUpOff();
		 	
	SpeakerOff();
	PowerDspOff();
	Power5VOff();
	 
	//power down mode (SM2..0 = 010)
	MCUCR &= ~BIT(SM0);
	MCUCR |= BIT(SM1);
	MCUCR &= ~BIT(SM2);
	MCUCR |= BIT(SE);
	
	asm("SLEEP");
	
	//ߣ
	StateOpenPullUpOn();
	StateClosePullUpOn();
}

void Check_Vin()
{
    U8 i, ADValue;
	U8 ADCHTmp;
	
	//ADMUX  ѡADͨ6,ѡڲοѹ2.56V,
	//| REFS1 | REFS0 | ADLAR | - | MUX3 | MUX2 | MUX1 | MUX0 |
	//	  1       1       1     0     0      1      1      0
    ADMUX = 0xE6;
	//ADCSRA ADENλ,ѡת,رADж,Ƶ = 8
	//| ADEN | ADSC | ADFR | ADIF | ADIE | ADPS2 | ADPS1 | ADPS0 |
	//    1      0      0      0      0      0       1       1
	ADCSRA = 0x83;
	
	ADCtrlOn();
		
	DelayMS(10);
	//AD
	ADCSRA |= 0x40;
	//жADǷ
	for (i = 0; i < 50; i++)
	{
	 	if ((ADCSRA & 0x10) != 0) break;
		DelayMS(1);
	}
	DelayMS(10);
	
	ADCHTmp = (U8)ADCH;
	if (i >= 50 || ADCHTmp < (U8)0x9A) Buzzer (1500, 1);//5VΪ(0x95)
	//ADH
	ADValue = ADCH;	
//	EEPROM_WRITE (0x0000, ADValue);
	ADValue = ADCL;
//	EEPROM_WRITE (0x0001, ADValue);
	
	
	//رADADENλ
	ADCSRA &= 0x7F;
	
	ADCtrlOff();
}	

void main()
{
 	U8 i, m;
	U8 bCatchOn;
	U32 RsTimeCnt;

 	Init_Devices();
	
	Check_Vin();
	
	Buzzer(Beep_Short, 1);				 //ѡһ
	PowerDspOn();
	DelayMS(100);
	
	
	for (i = 0; i < 5; i++)
	{ 		
		WDR();
		//PowerDspOn();
		
		Rst_Dsp();		
		
		Power5VOn();
		gFlagInput = 0;		
		
		///ɾ/ȫɾںϵ״̬
		if ((PINB & 0x07) == 0)
		{
		   	LightGreenFlashOn();	
		   	while ((PINB & 0x07) == 0)
			{
			 	//ȴ
				bCatchOn = FALSE;
				gRsLength = 0;
				RsTimeCnt = 120000;
				while (gRsLength < 8 && RsTimeCnt > 0)
				{
				    WDR();
					RsTimeCnt--;		
					//bCatchOn½
					if (IsSensorOn() == TRUE)
					{
		    		   	bCatchOn = TRUE;
					}
					else if (bCatchOn == TRUE)
					{
		    		 	bCatchOn = FALSE;
						Buzzer(Beep_Short, 1);
					}
				}
				if (gRsLength >= 8)
				{
				    if (gRsBuf[1] == CMD_LP_MODE) goto full_sleep_mode;
				}
			}
		
			LightGreenFlashOff();
		}
		
		m = NormalProcess();
		
		if (m != 0xFF) break;
		
		//PowerDspOff();
		Power5VOff();
		DelayMS(150);
		WDR(); 	
	}	
	
	if (m == ACK_SUCCESS)
	{
	 	//
		PowerDspOff();	
		Power5VOff();
		gDoorCloseEnable = FALSE;	 
		DoorOpenProcess();
		if (IsDoorClosed() == TRUE)
		{
	   	   DelayMS (700);
		}
	}	
	else if (m == ACK_TIMEOUT)
	{
	 	//޲		
	}
	else if (m == ACK_GO_OUT)
	{			
		//̲
		while (1)
		{
		 	Rst_Dsp();
			
	 	 	m = KeyProcess();
			if (m == ACK_TIMEOUT)
			{
			   	 break;
			}			
		}
	}
	
	//
sleep_mode:
	
	gDoorCloseEnable = FALSE;	 	   	
	while (IsStateClose() != TRUE)
	{
	 	GICR  = 0x80;
	 	Sleep_Board(TRUE);
		
		if (IsDoorClosed() == TRUE)
		{	
			GICR = 0x00;	   
		   	DelayMS (700);
		    if (IsDoorClosed() == TRUE)
		    {
	       	    DoorCloseProcess();
		    }
		}
	}
full_sleep_mode:
	GICR  = 0x00;//Int1ж
	while (1)
	{
	 	Sleep_Board(FALSE);
	}			
}		
		
		   	     

