// CommTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "STTStar.h"
#include "CommTestDlg.h"
#include "CmdHead.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define IMAGE_WIDTH		304
#define IMAGE_HEIGHT	304
#define TYPE_MAX		13
int gpImageWidth[TYPE_MAX] = {304, 280, 256, 256, 196, 160, 248, 280, 240, 248, 256, 256, 200};
int gpImageHeight[TYPE_MAX] = {304, 280, 280, 256, 196, 208, 280, 240, 312, 296, 292, 296, 264};

int  gnBaud = 2;
int  gnPort = 1;

int  gnFeaIndx = 0;
int  gnFeaCnt = 0;
DWORD gpIDBuf[1000];
char gpFeaBuf[1000][256];
bool gbBatch;

int  gnLenCmd = 0;	
int  gnLenAck = 0;
BYTE gpCmdDataBuf[SECT_LEN * 2 + 4];
BYTE gpAckDataBuf[304 * 304 + 1000];
BYTE gpImage[304 * 304];
WORD gpRandBuf[8];

void sort_DWORD (DWORD *e1, WORD s)
{
	int  i, j;
	DWORD p;
	j = s;
	do
	{
		for (i = 1; i <= j - 1; i++)
		{
			if (*(e1 + i - 1) > *(e1 + i))
			{
				p = *(e1 + i);
				*(e1 + i) = *(e1 + i - 1);
				*(e1 + i - 1) = p;
			}
		}
		j--;
	}while(j > 1);
}

/////////////////////////////////////////////////////////////////////////////
// CCommTestDlg dialog

CCommTestDlg::CCommTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCommTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCommTestDlg)
	m_nType = -1;
	m_strFeaPath = _T("");
	m_nMoveRight = 0;
	m_nMoveUp = 0;
	m_nLumEnc = 0;
	m_bIDEnc1 = FALSE;
	m_bTwice = FALSE;
	m_bUpload = FALSE;
	m_nCapTime = 0;
	m_bIDEnc2 = FALSE;
	m_b2FP = FALSE;
	m_bImgRaw = FALSE;
	m_nBatchCnt = 0;
	m_nBatchIndx = 0;
	m_bEnableBatch = FALSE;
	m_bGetStorage = FALSE;
	//}}AFX_DATA_INIT
}


void CCommTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCommTestDlg)
	DDX_Control(pDX, IDC_EDIT_BATCH_INDX, m_editBatchIndx);
	DDX_Control(pDX, IDC_EDIT_BATCH_CNT, m_editBatchCnt);
	DDX_Control(pDX, IDC_STATIC_BATCH_INDX, m_staticBatchIndx);
	DDX_Control(pDX, IDC_STATIC_BATCH_CNT, m_staticBatchCnt);
	DDX_Control(pDX, IDC_BTN_BATCH, m_btnBatch);
	DDX_Control(pDX, IDC_BUTTON_ENABLE, m_btnEnable);
	DDX_Control(pDX, IDC_PARM3, m_editParm3);
	DDX_Control(pDX, IDC_PARM2, m_editParm2);
	DDX_Control(pDX, IDC_PARM12, m_editParm12);
	DDX_Control(pDX, IDC_PARM1, m_editParm1);
	DDX_Control(pDX, IDC_EDIT_FEATURE_PATH, m_editFeaPath);
	DDX_Control(pDX, IDC_EDIT_CMD, m_editCmd);
	DDX_Control(pDX, IDC_EDIT_ACK_INFO, m_editAckInfo);
	DDX_Control(pDX, IDC_EDIT_ACK_CODE, m_editAckCode);
	DDX_Control(pDX, IDC_BUTTON_STORE_FEATURE, m_btnStoreFea);
	DDX_Control(pDX, IDC_BUTTON_CMD, m_btnCmd);
	DDX_Control(pDX, IDC_BUTTON_FEATURE_BROWSE, m_btnBrowse);
	DDX_Control(pDX, IDC_BUTTON_BMP, m_btnBmp);
	DDX_Radio(pDX, IDC_RADIO_GET_USERCNT, m_nType);
	DDX_Control(pDX, IDC_MSCOMM1, m_mscomm);
	DDX_Text(pDX, IDC_EDIT_FEATURE_PATH, m_strFeaPath);
	DDX_Text(pDX, IDC_EDIT_MOVE_RIGHT, m_nMoveRight);
	DDX_Text(pDX, IDC_EDIT_MOVE_UP, m_nMoveUp);
	DDX_Text(pDX, IDC_EDIT_LUM_ENC, m_nLumEnc);
	DDX_Check(pDX, IDC_CHECK_IDENC_1, m_bIDEnc1);
	DDX_Check(pDX, IDC_CHECK_TWICE, m_bTwice);
	DDX_Check(pDX, IDC_CHECK_UPLOAD, m_bUpload);
	DDX_Text(pDX, IDC_EDIT_CAPTIME, m_nCapTime);
	DDX_Check(pDX, IDC_CHECK_IDENC_2, m_bIDEnc2);
	DDX_Check(pDX, IDC_CHECK_2FP, m_b2FP);
	DDX_Check(pDX, IDC_CHECK_IMG_RAW, m_bImgRaw);
	DDX_Text(pDX, IDC_EDIT_BATCH_CNT, m_nBatchCnt);
	DDX_Text(pDX, IDC_EDIT_BATCH_INDX, m_nBatchIndx);
	DDX_Check(pDX, IDC_CHECK_ENABLE_BATCH, m_bEnableBatch);
	DDX_Check(pDX, IDC_CHECK_GET_STORAGE, m_bGetStorage);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCommTestDlg, CDialog)
	//{{AFX_MSG_MAP(CCommTestDlg)
	ON_BN_CLICKED(IDC_RADIO_GET_USERCNT, OnRadioGetUsercnt)
	ON_BN_CLICKED(IDC_RADIO_USER_REG, OnRadioUserReg)
	ON_BN_CLICKED(IDC_RADIO_GET_USERROLE, OnRadioGetUserrole)
	ON_BN_CLICKED(IDC_RADIO_DEL_USER, OnRadioDelUser)
	ON_BN_CLICKED(IDC_RADIO_DEL_ALLUSER, OnRadioDelAlluser)
	ON_BN_CLICKED(IDC_RADIO_MATCH_1, OnRadioMatch1)
	ON_BN_CLICKED(IDC_RADIO_MATCH_N, OnRadioMatchN)
	ON_BN_CLICKED(IDC_RADIO_GET_IMAGE, OnRadioGetImage)
	ON_BN_CLICKED(IDC_RADIO_DOWN_FEATURE, OnRadioDownFeature)
	ON_BN_CLICKED(IDC_RADIO_DOWN_MATCH, OnRadioDownMatch)
	ON_BN_CLICKED(IDC_RADIO_DOWN_MATCH_1, OnRadioDownMatch1)
	ON_BN_CLICKED(IDC_RADIO_DOWN_MATCH_N, OnRadioDownMatchN)
	ON_BN_CLICKED(IDC_RADIO_UP_FEATURE, OnRadioUpFeature)
	ON_BN_CLICKED(IDC_RADIO_GET_FEATURE, OnRadioGetFeature)
	ON_BN_CLICKED(IDC_RADIO_SET_REG, OnRadioSetReg)
	ON_BN_CLICKED(IDC_RADIO_COMM_TEST, OnRadioCommTest)
	ON_BN_CLICKED(IDC_RADIO_GET_VERSION, OnRadioGetVersion)
	ON_BN_CLICKED(IDC_BUTTON_CMD, OnButtonCmd)
	ON_BN_CLICKED(IDC_BUTTON_ENABLE, OnButtonEnable)
	ON_BN_CLICKED(IDC_BUTTON_FEATURE_BROWSE, OnButtonFeatureBrowse)
	ON_BN_CLICKED(IDC_BUTTON_STORE_FEATURE, OnButtonStoreFeature)
	ON_WM_TIMER()
	ON_EN_CHANGE(IDC_PARM1, OnChangeParm1)
	ON_EN_CHANGE(IDC_PARM2, OnChangeParm2)
	ON_EN_CHANGE(IDC_PARM3, OnChangeParm3)
	ON_EN_CHANGE(IDC_PARM12, OnChangeParm12)
	ON_BN_CLICKED(IDC_RADIO_SET_MATCH_LEVEL, OnRadioSetMatchLevel)
	ON_BN_CLICKED(IDC_RADIO_GET_USER_INFO, OnRadioGetUserInfo)
	ON_BN_CLICKED(IDC_RADIO_SET_LP_MODE, OnRadioSetLpMode)
	ON_BN_CLICKED(IDC_RADIO_SET_ENROLL_MODE, OnRadioSetEnrollMode)
	ON_BN_CLICKED(IDC_RADIO_GET_ONE_RECORD, OnRadioGetOneRecord)
	ON_BN_CLICKED(IDC_RADIO_GET_NEW_RECORD, OnRadioGetNewRecord)
	ON_BN_CLICKED(IDC_RADIO_CLEAR_RECORD, OnRadioClearRecord)
	ON_BN_CLICKED(IDC_RADIO_SET_TIME, OnRadioSetTime)
	ON_BN_CLICKED(IDC_RADIO_GET_TIME, OnRadioGetTime)
	ON_BN_CLICKED(IDC_BTN_MOVE_RIGHT, OnBtnMoveRight)
	ON_BN_CLICKED(IDC_BTN_MOVE_UP, OnBtnMoveUp)
	ON_BN_CLICKED(IDC_CHECK_TWICE, OnCheckTwice)
	ON_BN_CLICKED(IDC_CHECK_UPLOAD, OnCheckUpload)
	ON_BN_CLICKED(IDC_CHECK_IDENC_1, OnCheckIdenc1)
	ON_BN_CLICKED(IDC_BTN_LUM, OnBtnLum)
	ON_BN_CLICKED(IDC_CHECK_2FP, OnCheck2fp)
	ON_BN_CLICKED(IDC_CHECK_IMG_RAW, OnCheckImgRaw)
	ON_BN_CLICKED(IDC_CHECK_IDENC_2, OnCheckIdenc2)
	ON_BN_CLICKED(IDC_RADIO_LUM_ADJUST, OnLumAdjust)
	ON_BN_CLICKED(IDC_BTN_BATCH, OnBtnBatch)
	ON_BN_CLICKED(IDC_CHECK_ENABLE_BATCH, OnCheckEnableBatch)
	ON_BN_CLICKED(IDC_CHECK_GET_STORAGE, OnCheckGetStorage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCommTestDlg message handlers
void CCommTestDlg::CommSettings(int nBaud)
{
	switch (nBaud)
	{
	case 1:	
		m_mscomm.SetSettings("9600,n,8,1");
		break;
	case 2:
	default:
		m_mscomm.SetSettings("19200,n,8,1");
		break;
	case 3:
		m_mscomm.SetSettings("38400,n,8,1");
		break;
	case 4:
		m_mscomm.SetSettings("57600,n,8,1");
		break;
	case 5:
		m_mscomm.SetSettings("115200,n,8,1");
		break;
	}
}

int CCommTestDlg::RCVCommand(BYTE *pCmd)
{
	int       lenCmd;
	VARIANT   varCmd;
	SAFEARRAY *pArray;
	
	varCmd=m_mscomm.GetInput();
	pArray=(SAFEARRAY *)varCmd.plVal;
	lenCmd=pArray->rgsabound[0].cElements;
	memcpy(pCmd,pArray->pvData,lenCmd);

	return   lenCmd;
}

void CCommTestDlg::TXCommand(BYTE *pCmd, int lenCmd)
{
	VARIANT   varCmd;
	SAFEARRAY safeArray;

	safeArray.fFeatures=VT_VARIANT;
	safeArray.cbElements=1;
	safeArray.cDims=1;
	safeArray.cLocks=0;
	safeArray.pvData=(LPVOID)pCmd;

	safeArray.rgsabound[0].cElements=lenCmd;
	safeArray.rgsabound[0].lLbound=0;

	VariantInit(&varCmd);
	varCmd.vt=0x2011;//VT_ARRAY|VT_BOOL;
	varCmd.plVal=(long*)&safeArray;
	m_mscomm.SetOutput(varCmd);
}

void CCommTestDlg::Init()
{
	//init comm
	m_mscomm.SetCommPort(gnPort);
	CommSettings(gnBaud);
/*	if(!m_mscomm.GetPortOpen())
	{
		m_mscomm.SetPortOpen(true);
	}	
*/
	m_mscomm.SetInputMode(1);//byte mode
		
	m_mscomm.SetRThreshold(1);
	m_mscomm.SetInputLen(9000);	

	//Init status
	m_editCmd.SetWindowText("");

	m_btnStoreFea.EnableWindow(false);
	m_nType=0;
	UpdateData(false);
	m_bEditChange = false;
	CmdRefresh();
}

void CCommTestDlg::CmdRefresh()
{
	int i;
	int lLen;

	WORD wUserID = 0;
	BYTE byUserRole = 0;
	BYTE byUserCount = 0;

	char strSub[10];
	char str[200];

	UpdateData(true);

	m_btnStoreFea.EnableWindow(false);
	m_bFea = false;

	switch(m_nType)
	{
	case RADIO_GET_USER_SUM_DB:
		m_editParm1.EnableWindow(false);
		m_editParm2.EnableWindow(false);
		m_editParm3.EnableWindow(false);
		m_editParm12.EnableWindow(false);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);
		
		gpCmdDataBuf[1] = CMD_GET_USER_SUM_DB;
		gpCmdDataBuf[2] = 0;
		gpCmdDataBuf[3] = 0;
		if (m_bGetStorage)
		{
			gpCmdDataBuf[4] = 0xFF;
		}
		else
		{
			gpCmdDataBuf[4] = 0;
		}
		gnLenCmd = 8;
		break;

	case RADIO_REG_DB:
		m_editParm1.EnableWindow(true);
		m_editParm2.EnableWindow(true);
		m_editParm3.EnableWindow(true);
		m_editParm12.EnableWindow(true);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		if(gbRegStart)
		{
			gpCmdDataBuf[1] = CMD_REG_START_DB;
		}
		
		gpCmdDataBuf[2] = (BYTE)GetParm(1);
		gpCmdDataBuf[3] = (BYTE)GetParm(2);
		gpCmdDataBuf[4] = (BYTE)GetParm(3);

		gnLenCmd = 8;
		break;

	case RADIO_GET_USER_RIGHT_DB:
		m_editParm1.EnableWindow(true);
		m_editParm2.EnableWindow(true);
		m_editParm3.EnableWindow(false);
		m_editParm12.EnableWindow(true);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_GET_USER_RIGHT_DB;
		
		gpCmdDataBuf[2] = (BYTE)GetParm(1);
		gpCmdDataBuf[3] = (BYTE)GetParm(2);
		gpCmdDataBuf[4] = 0;

		gnLenCmd = 8;
		break;

	case RADIO_REG_DELETE_DB:
		m_editParm1.EnableWindow(true);
		m_editParm2.EnableWindow(true);
		m_editParm3.EnableWindow(false);
		m_editParm12.EnableWindow(true);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_REG_DELETE_DB;
		gpCmdDataBuf[2] = (BYTE)GetParm(1);
		gpCmdDataBuf[3] = (BYTE)GetParm(2);
		gpCmdDataBuf[4] = 0;

		gnLenCmd = 8;
		break;

	case RADIO_REG_ALLDEL_DB:
		m_editParm1.EnableWindow(false);
		m_editParm2.EnableWindow(false);
		m_editParm3.EnableWindow(true);
		m_editParm12.EnableWindow(false);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_REG_ALLDEL_DB;
		gpCmdDataBuf[2] = 0;
		gpCmdDataBuf[3] = 0;
		gpCmdDataBuf[4] = (BYTE)GetParm(3);

		gnLenCmd = 8;
		break;
	
	case RADIO_VERIFY_DB:
		m_editParm1.EnableWindow(true);
		m_editParm2.EnableWindow(true);
		m_editParm3.EnableWindow(false);
		m_editParm12.EnableWindow(true);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_VERIFY_DB;	
		gpCmdDataBuf[2] = (BYTE)GetParm(1);
		gpCmdDataBuf[3] = (BYTE)GetParm(2);
		gpCmdDataBuf[4] = 0;

		gnLenCmd = 8;
		break;	

	case RADIO_IDENTIFY_DB:
		m_editParm1.EnableWindow(false);
		m_editParm2.EnableWindow(false);
		m_editParm3.EnableWindow(true);
		m_editParm12.EnableWindow(false);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_IDENTIFY_DB;
		gpCmdDataBuf[2] = 0;
		gpCmdDataBuf[3] = 0;
		gpCmdDataBuf[4] = (BYTE)GetParm(3);

		gnLenCmd = 8;
		break;

	case RADIO_GET_IMAGE:
		m_editParm1.EnableWindow(false);
		m_editParm2.EnableWindow(false);
		m_editParm3.EnableWindow(false);
		m_editParm12.EnableWindow(false);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_GET_IMAGE;
		gpCmdDataBuf[2] = 0;
		gpCmdDataBuf[3] = 0;
		if (m_bImgRaw)
		{
			gpCmdDataBuf[4] = ST_IMAGE_RAW;
		}
		else
		{
			gpCmdDataBuf[4] = 0;
		}

		gnLenCmd = 8;
		break;		

	case RADIO_FROM_VALUE_DB:
		m_editParm1.EnableWindow(true);
		m_editParm2.EnableWindow(true);
		m_editParm3.EnableWindow(true);
		m_editParm12.EnableWindow(true);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(true);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1]=CMD_FROM_VALUE_DB;
		gpCmdDataBuf[2] = 0 ;
		gpCmdDataBuf[3] = FEA_LEN + 3;
		gpCmdDataBuf[4] = 0;

		gpCmdDataBuf[9] = (BYTE)GetParm(1);
		gpCmdDataBuf[10] = (BYTE)GetParm(2);
		gpCmdDataBuf[11] = (BYTE)GetParm(3);
		
		gnLenCmd = gpCmdDataBuf[2] * 256 + gpCmdDataBuf[3] + 11;

		m_bFea = true;
		break;

	case RADIO_FROM_VERIFY:
		m_editParm1.EnableWindow(false);
		m_editParm2.EnableWindow(false);
		m_editParm3.EnableWindow(false);
		m_editParm12.EnableWindow(false);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(true);
		m_btnStoreFea.EnableWindow(false);

		if (m_b2FP)	
		{				
			gpCmdDataBuf[1] = CMD_FROM_VERIFY_2;
			lLen = 3 + 2 * FEA_LEN;
		}
		else
		{
			gpCmdDataBuf[1] = CMD_FROM_VERIFY;
			lLen = 3 + FEA_LEN;
		}

		gpCmdDataBuf[2] = lLen >> 8;
		gpCmdDataBuf[3] = lLen & 0xFF;
		
		gpCmdDataBuf[4] = 0;
		gpCmdDataBuf[9] = 0;
		gpCmdDataBuf[10] = 0;
		gpCmdDataBuf[11] = 0;
		
		gnLenCmd = gpCmdDataBuf[2] * 256 + gpCmdDataBuf[3] + 11;

		m_bFea = true;
		break;

	case RADIO_FROM_VERIFY_DB:
		m_editParm1.EnableWindow(true);
		m_editParm2.EnableWindow(true);
		m_editParm3.EnableWindow(false);
		m_editParm12.EnableWindow(true);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(true);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_FROM_VERIFY_DB;		
		gpCmdDataBuf[2] = 0;
		gpCmdDataBuf[3] = FEA_LEN + 3;
		gpCmdDataBuf[4] = 0;

		gpCmdDataBuf[9] = (BYTE)GetParm(1) ;
		gpCmdDataBuf[10] = (BYTE)GetParm(2);
		gpCmdDataBuf[11] = 0;
		
		gnLenCmd = gpCmdDataBuf[2] * 256 + gpCmdDataBuf[3] + 11;

		m_bFea = true;
		break;

	case RADIO_FROM_IDENTIFY_DB:
		m_editParm1.EnableWindow(false);
		m_editParm2.EnableWindow(false);
		m_editParm3.EnableWindow(false);
		m_editParm12.EnableWindow(false);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(true);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_FROM_IDENTIFY_DB;
		gpCmdDataBuf[2] = 0;
		gpCmdDataBuf[3] = FEA_LEN + 3;
		gpCmdDataBuf[4] = 0;

		gpCmdDataBuf[9] = 0;
		gpCmdDataBuf[10] = 0;
		gpCmdDataBuf[11] = 0;
		
		gnLenCmd = gpCmdDataBuf[2] * 256 + gpCmdDataBuf[3] + 11;

		m_bFea = true;
		break;
	
	case RADIO_TO_VALUE_DB:
		m_editParm1.EnableWindow(true);
		m_editParm2.EnableWindow(true);
		m_editParm3.EnableWindow(false);
		m_editParm12.EnableWindow(true);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);


		gpCmdDataBuf[1] = CMD_TO_VALUE_DB;
		
		gpCmdDataBuf[2] = (BYTE)GetParm(1);
		gpCmdDataBuf[3] = (BYTE)GetParm(2);
		gpCmdDataBuf[4] = 0;
		gnLenCmd = 8;
		break;	

	case RADIO_GET_VALUE:
		m_editParm1.EnableWindow(false);
		m_editParm2.EnableWindow(false);
		m_editParm3.EnableWindow(false);
		m_editParm12.EnableWindow(false);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);


		gpCmdDataBuf[1] = CMD_GET_VALUE;
		gpCmdDataBuf[2] = 0;
		gpCmdDataBuf[3] = 0;
		gpCmdDataBuf[4] = 0;

		gnLenCmd = 8;
		break;		

/*	case RADIO_TEST_COMM:
		m_editParm1.EnableWindow(false);
		m_editParm2.EnableWindow(false);
		m_editParm3.EnableWindow(false);
		m_editParm12.EnableWindow(false);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_TEST_COMM;
		gpCmdDataBuf[2] = 0;
		gpCmdDataBuf[3] = 0;
		gpCmdDataBuf[4] = 0;

		gnLenCmd = 8;
		break;
*/
	case RADIO_GET_USER_INFO:
		m_editParm1.EnableWindow(false);
		m_editParm2.EnableWindow(false);
		m_editParm3.EnableWindow(false);
		m_editParm12.EnableWindow(false);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_GET_USER_INFO;
		gpCmdDataBuf[2] = 0;
		gpCmdDataBuf[3] = 0;
		gpCmdDataBuf[4] = 0;
		
		gnLenCmd = 8;
		break;

	case RADIO_SET_LP_MODE:
		m_editParm1.EnableWindow(false);
		m_editParm2.EnableWindow(false);
		m_editParm3.EnableWindow(false);
		m_editParm12.EnableWindow(false);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_SET_LP_MODE;
		gpCmdDataBuf[2] = 0;
		gpCmdDataBuf[3] = 0;
		gpCmdDataBuf[4] = 0;

		gnLenCmd = 8;
		break;

	case RADIO_GET_VERSION:
		m_editParm1.EnableWindow(false);
		m_editParm2.EnableWindow(false);
		m_editParm3.EnableWindow(false);
		m_editParm12.EnableWindow(false);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_GET_VERSION;
		gpCmdDataBuf[2] = 0;
		gpCmdDataBuf[3] = 0;
		gpCmdDataBuf[4] = 0;

		gnLenCmd = 8;
		break;	

	case RADIO_SET_MATCH_LEVEL:
		m_editParm1.EnableWindow(false);
		m_editParm2.EnableWindow(true);
		m_editParm3.EnableWindow(true);
		m_editParm12.EnableWindow(false);
		m_editFeaPath.EnableWindow(true);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_SET_MATCH_LEVEL;
		gpCmdDataBuf[2] = 0;
		gpCmdDataBuf[3] = (BYTE)GetParm(2);
		gpCmdDataBuf[4] = (BYTE)GetParm(3);

		gnLenCmd = 8;
		break;

	case RADIO_GET_LUM:
		m_editParm1.EnableWindow(false);
		m_editParm2.EnableWindow(false);
		m_editParm3.EnableWindow(false);
		m_editParm12.EnableWindow(false);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_GET_LUM;
		gpCmdDataBuf[2] = 0;
		gpCmdDataBuf[3] = 0;
		gpCmdDataBuf[4] = 0;

		gnLenCmd = 8;
		break;

	case RADIO_LUM_ADJUST:
		m_editParm1.EnableWindow(false);
		m_editParm2.EnableWindow(false);
		m_editParm3.EnableWindow(true);
		m_editParm12.EnableWindow(false);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_LUM_ADJUST;
		gpCmdDataBuf[2] = 0;
		gpCmdDataBuf[3] = 0;
		gpCmdDataBuf[4] = (BYTE)GetParm(3);;

		gnLenCmd = 8;
		break;

	case RADIO_GET_ONE_RECORD:
		m_editParm1.EnableWindow(true);
		m_editParm2.EnableWindow(true);
		m_editParm3.EnableWindow(false);
		m_editParm12.EnableWindow(true);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_GET_ONE_RECORD;
		gpCmdDataBuf[2] = (BYTE)GetParm(1);
		gpCmdDataBuf[3] = (BYTE)GetParm(2);
		gpCmdDataBuf[4] = 0;

		gnLenCmd = 8;
		break;
	
	case RADIO_GET_NEW_RECORD:
		m_editParm1.EnableWindow(true);
		m_editParm2.EnableWindow(true);
		m_editParm3.EnableWindow(true);
		m_editParm12.EnableWindow(false);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_GET_NEW_RECORD;
		gpCmdDataBuf[2] = (BYTE)GetParm(1);;
		gpCmdDataBuf[3] = (BYTE)GetParm(2);;
		gpCmdDataBuf[4] = (BYTE)GetParm(3);;

		gnLenCmd = 8;
		break;

	case RADIO_CLEAR_RECORD:
		m_editParm1.EnableWindow(false);
		m_editParm2.EnableWindow(false);
		m_editParm3.EnableWindow(false);
		m_editParm12.EnableWindow(false);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_CLEAR_RECORD;
		gpCmdDataBuf[2] = 0;
		gpCmdDataBuf[3] = 0;
		gpCmdDataBuf[4] = 0;

		gnLenCmd = 8;
		break;

	case RADIO_SET_REG:
		m_editParm1.EnableWindow(true);
		m_editParm2.EnableWindow(true);
		m_editParm3.EnableWindow(true);
		m_editParm12.EnableWindow(true);
		m_editFeaPath.EnableWindow(false);
		m_btnBrowse.EnableWindow(false);
		m_btnStoreFea.EnableWindow(false);

		gpCmdDataBuf[1] = CMD_SET_REG;
		gpCmdDataBuf[2] = (BYTE)GetParm(1);
		gpCmdDataBuf[3] = (BYTE)GetParm(2);
		gpCmdDataBuf[4] = (BYTE)GetParm(3);
		
		gnLenCmd = 8;
		break;
	}	

	//Update the first part of gpCmdDataBuf
	gpCmdDataBuf[0] = CMD_HEAD;
	gpCmdDataBuf[5] = CMD_CH;
	gpCmdDataBuf[7] = CMD_TAIL;

	BYTE byXor = 0;

	for (i = 1; i <= 5; i++)
	{
		byXor ^= gpCmdDataBuf[i];
	}
	gpCmdDataBuf[6] = byXor;
		
	strcpy(str, "");
	for (i = 0; i < 8; i++)
	{
		itoa(gpCmdDataBuf[i], strSub, 16);
		
		if (strlen(strSub) < 2) 
		{	
			strSub[1] = strSub[0];
			strSub[0] = '0';
		}
		strSub[2] = '\0';
		strcat(str, strSub);
		strcat(str, " ");
	}
	m_editCmd.SetWindowText(str);
}

WORD CCommTestDlg::GetParm(int nIndx)
{
	int i;
	WORD  wParm;
	char  chVal;
	char  pBuf[10];
	switch (nIndx)
	{
	case 1:
		m_editParm1.GetWindowText(pBuf, 10);
		if (strlen(pBuf) > 2) pBuf[2] = '\0';
		break;
	case 2:
		m_editParm2.GetWindowText(pBuf, 10);
		if (strlen(pBuf) > 2) pBuf[2] = '\0';
		break;
	case 3:
		m_editParm3.GetWindowText(pBuf, 10);
		if (strlen(pBuf) > 2) pBuf[2] = '\0';
		break;
	case 4:
	default:
		m_editParm12.GetWindowText(pBuf, 10);
		if (strlen(pBuf) > 4) pBuf[4] = '\0';
		break;
	}

	wParm = 0;
	for (i = 0; i < int(strlen(pBuf)); i++)
	{
		wParm *= 16;	
		chVal = pBuf[i];
		if (isupper(chVal))
		{
			wParm += chVal - 'A' + 10;
		}
		else if(islower(chVal))
		{
			wParm += chVal-'a'+10;
		}
		else
		{
			wParm += chVal-'0';
		}		
	}	

	return wParm;
}

void CCommTestDlg::OnRadioGetUsercnt() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioUserReg() 
{
	gbRegStart = true;
	CmdRefresh();	
}

void CCommTestDlg::OnRadioGetUserrole() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioDelUser() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioDelAlluser() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioMatch1() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioMatchN() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioGetImage() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioDownFeature() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioDownMatch() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioDownMatch1() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioDownMatchN() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioUpFeature() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioGetFeature() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioSetReg() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioCommTest() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioGetVersion() 
{
	CmdRefresh();	
}


void CCommTestDlg::OnRadioSetMatchLevel() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnCmdInter()
{
	int nStart = -1;
	BYTE byXor;
	int  i;
	
	if (gbBatch)
	{
		gpCmdDataBuf[9] = (gpIDBuf[gnFeaIndx] >> 16) >> 8;
		gpCmdDataBuf[10] = (gpIDBuf[gnFeaIndx] >> 16) & 0xFF;
		gpCmdDataBuf[11] = 0x01;
		memcpy (gpCmdDataBuf + 12, gpFeaBuf[gpIDBuf[gnFeaIndx] & 0xFFFF], FEA_LEN);
	}
	else
	{
		switch (gpCmdDataBuf[1])
		{
		case CMD_REG_START_DB:
			nStart = 2; 
			break;
		case CMD_FROM_VALUE_DB:
			nStart = 9; 
			break;		
		}
		if (nStart >= 0)
		{
			UpdateData (true);	
			if (gpCmdDataBuf[nStart] == 0 && gpCmdDataBuf[nStart + 1] == 0)
			{
				if (gpCmdDataBuf[1] != CMD_REG_START_DB || (!m_bUpload))			
				{
					MessageBox("ûŲΪ0");
					return;
				}
			}
			if (gpCmdDataBuf[nStart + 2] == 0)
			{
				if (gpCmdDataBuf[1] != CMD_REG_START_DB || (!m_bUpload))
				{
					MessageBox("ȨЧ");
					return;
				}
			}
		}
		
		if (m_bFea)
		{
			if (!ReadFeature()) return;
		}
	}

	//Update the Second part of gpCmdDataBuf
	if (gnLenCmd > 8)
	{
		gpCmdDataBuf[8] = CMD_HEAD;
		gpCmdDataBuf[gnLenCmd - 1] = CMD_TAIL;
		byXor = 0;
		for (i = 9; i < gnLenCmd - 2; i++)
		{
			byXor ^= gpCmdDataBuf[i];
		}
		gpCmdDataBuf[gnLenCmd - 2] = byXor;
	}

	TXCommand (gpCmdDataBuf, gnLenCmd);
	m_editAckInfo.SetWindowText("");
	m_editAckCode.SetWindowText("");
//	m_btnCmd.EnableWindow(false);
	gnLenAck = 0;	
}

void CCommTestDlg::OnButtonCmd() 
{
	gbBatch = FALSE;
	OnCmdInter();
}

void CCommTestDlg::OnButtonEnable() 
{
	m_btnCmd.EnableWindow(true);	
}

void CCommTestDlg::OnButtonFeatureBrowse() 
{	
	CFileDialog fileDlg(true,"fea","feature",
								OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
								"feature files (*.fea)|*.fea|");
	if (fileDlg.DoModal() == IDCANCEL)
	{		
		return;
	}
	m_strFeaPath = fileDlg.GetPathName();
	UpdateData (false);			
}

void CCommTestDlg::OnButtonStoreFeature() 
{
	CString strFileName;
	CFileDialog fileDlg(false,"fea","feature",
								OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
								"feature files (*.fea)|*.fea|");
	if (fileDlg.DoModal() == IDCANCEL)
	{		
		return;
	}
	strFileName = fileDlg.GetPathName();

	//open feature data file for write
	CFile f;
	if (f.Open(strFileName, CFile::modeCreate | CFile::modeWrite) == NULL)
	{
		AfxMessageBox("޷ " + strFileName);
		return;
	}
	
	f.Write(&gpAckDataBuf[12], sizeof(BYTE) * FEA_LEN);
	f.Close();		
}

BEGIN_EVENTSINK_MAP(CCommTestDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CCommTestDlg)
	ON_EVENT(CCommTestDlg, IDC_MSCOMM1, 1 /* OnComm */, OnOnCommMscomm1, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CCommTestDlg::OnOnCommMscomm1() 
{
	int nEvent;

	nEvent = m_mscomm.GetCommEvent();
	if (gnBaud == 0)
	{
		gnBaud = 1;
	}
	if (nEvent == EVENT_RCV)
	{
		m_mscomm.SetRThreshold(9000);
		SetTimer(TIMER_RCV_DELAY, 50, NULL);
	}	
}

void CCommTestDlg::OnTimer(UINT nIDEvent) 
{
	int  i, j;
	WORD wTmp;
	int  lenAck = 0;
	char str1[10], strShow[304 * 304 * 3];

	switch (nIDEvent)
	{
	case TIMER_RCV_DELAY:		

		m_mscomm.SetRThreshold(1);
		
		lenAck = RCVCommand(&gpAckDataBuf[gnLenAck]);
		gnLenAck += lenAck;
		if (lenAck != 0 && gnLenAck < (304 * 304))
		{
			return;
		}
		
		m_btnCmd.EnableWindow(true);
		//ڽ
		KillTimer(TIMER_RCV_DELAY);	

		//ڽʾ		
		strcpy(strShow, "");

		UpdateData (true);
		
		for (i = 0; i < gnLenAck; i++)
		{
			/*itoa(gpAckDataBuf[i], str1, 16);
			if (strlen(str1) == 1)
			{
				str1[2] = '\0';
				str1[1] = str1[0];
				str1[0] = '0';
			}
			strcat(strShow, str1);
			strcat(strShow, " ");
			*/
			wTmp = gpAckDataBuf[i] / 16;
			if (wTmp >= 10) strShow[3 * i] = 'A' + wTmp - 10;
					   else strShow[3 * i] = '0' + wTmp;

			wTmp = gpAckDataBuf[i] % 16;
			if (wTmp >= 10) strShow[3 * i + 1] = 'A' + wTmp - 10;
					   else strShow[3 * i + 1] = '0' + wTmp;

			if (i == gnLenAck - 1) strShow[3 * i + 2] = 0;
							  else strShow[3 * i + 2] = ' ';
		}
		m_editAckCode.SetWindowText(strShow);

		itoa(gnLenAck, strShow, 10);		

		strcpy(strShow, "ʧ");
		
		//
		int nUserCnt = 0;
		int nUserID = 0;
		int nUserRole = 0;
		int nLen = 0;
		int nIndx = 0;

		switch (gpAckDataBuf[1])
		{
		case ACK_GET_USER_SUM_DB:
			nUserCnt = gpAckDataBuf[2] * 256 + gpAckDataBuf[3];
			if (gpAckDataBuf[4] == ST_SUCCESS || gpAckDataBuf[4] == 0xFF)
			{
				if (gpAckDataBuf[4] == 0xFF) strcpy(strShow, "ûΪ");
										else strcpy(strShow, "ûΪ");
				itoa(nUserCnt, str1, 10);
				strcat(strShow, str1);
			}
			else
			{
				strcpy(strShow, "ʧ");
			}			
			break;

		case ACK_REG_START_DB:
			if (gpAckDataBuf[4] == ST_TIMEOUT)
			{
				strcpy(strShow,"ɼָƳʱ");
			}
			else if (gpAckDataBuf[4] == ST_USER_OCCUPIED)
			{
				strcpy (strShow, "ûѴ");
			}
			else if (gpAckDataBuf[4] == ST_FINGER_OCCUPIED)
			{
				strcpy(strShow, "ָѴ");
			}
			else
			{
				strcpy(strShow,"û¼ʧ");
			}
			break;

		case ACK_REG_SECOND_DB:
			if (gpAckDataBuf[4] == ST_TIMEOUT)
			{
				strcpy(strShow,"ɼָƳʱ");
			}
			else
			{
				strcpy(strShow,"û¼ʧ");
			}
			break;

		case ACK_REG_END_DB:
			switch (gpAckDataBuf[4])
			{
			case ST_SUCCESS:
				strcpy(strShow, "û¼ɹ");
				UpdateData (true);
				if (m_bIDEnc1)
				{
					DWORD dwID;
					char  str1[10];
					dwID = GetParm (1) << 8;
					dwID += GetParm (2);

					dwID ++;
					
					itoa ((dwID >> 8) & 0xFF, str1, 16);
					m_editParm1.SetWindowText (str1);
					
					itoa (dwID & 0xFF, str1, 16);
					m_editParm2.SetWindowText (str1);

					OnChangeParm1 ();
				}	
				break;			
				
			case ST_TIMEOUT:
				strcpy(strShow, "ɼָƳʱ");
				break;
			
			case ST_USER_OCCUPIED:
				strcpy(strShow, "ûѴ");
				break;

			default:
				strcpy(strShow, "û¼ʧ");
				break;
			}
			break;	

		case ACK_REG_UPLOAD_DB:
			if (gnLenAck == 207)
			{
				strcpy (strShow, "ɹ");
			}
			else
			{
				strcpy (strShow, "ʧ");
			}
			break;

		case ACK_GET_USER_RIGHT_DB:
			nUserRole = gpAckDataBuf[4];
			switch (nUserRole)
			{			
			case ST_SYSMASTER:
				strcpy(strShow, "ûΪϵͳ");
				break;
			case ST_LIMMASTER:
				strcpy(strShow, "ûΪƹ");
				break;	
			case ST_COMMUSER:
				strcpy(strShow, "ûΪһʹ");
				break;	
			case ST_NO_USER:
				strcpy(strShow, "û");
				break;
			default:				
				strcpy(strShow,"ûΪδȨ");
			}
			break;

		case ACK_REG_DELETE_DB:
			if (gpAckDataBuf[4] == ST_SUCCESS)
			{
				strcpy(strShow, "ɹ");
			}
			else
			{
				strcpy(strShow, "ʧ");
			}
			break;	
			
		case ACK_REG_ALLDEL_DB:
			if (gpAckDataBuf[4] == ST_SUCCESS)
			{
				strcpy(strShow, "ɹ");
			}
			else
			{
				strcpy(strShow, "ʧ");
			}
			break;				
			
		case ACK_VERIFY_DB:
			switch (gpAckDataBuf[4])
			{
			case ST_SUCCESS:
				strcpy(strShow,"ָƱȶԳɹ");
				break;
			case ST_TIMEOUT:
				strcpy(strShow,"ָƲɼʱ");
				break;
			case ST_NO_USER:
				strcpy(strShow, "޴û");
				break;
			default:
				strcpy(strShow,"ָƱȶʧ");
				break;
			}
			break;	
			
		case ACK_IDENTIFY_DB:
			nUserID = gpAckDataBuf[2] * 256 + gpAckDataBuf[3];
			itoa(nUserID, str1, 10);
			switch (gpAckDataBuf[4])
			{
			case ST_TIMEOUT:
				strcpy(strShow,"ָƲɼʱ");
				break;
			case ST_NO_USER:
				strcpy(strShow,"ƥָ");
				break;						
			default:
				strcpy(strShow, str1);
				strcat(strShow,"ûȶԳɹ");
				break;				
			}
			break;

		case ACK_GET_IMAGE:
			switch (gpAckDataBuf[4])
			{
			case ST_SUCCESS:
			case ST_IMAGE_RAW:
				{
					int  IndxSrc = 9;
					int  IndxDest = 0;
					int  img_size;
					bool bRaw;
					int  cnt;

					if (gpAckDataBuf[4] == ST_IMAGE_RAW)
					{
						bRaw = TRUE;
					}
					else
					{
						bRaw = FALSE;
					}

					img_size = gpAckDataBuf[2] * 256 + gpAckDataBuf[3];

					memset (gpImage, 0, IMAGE_WIDTH * IMAGE_HEIGHT);
					
					for (cnt = 0; cnt < TYPE_MAX; cnt++)
					{
						if (img_size * 8 == gpImageWidth[cnt] * gpImageHeight[cnt])
						{
							if (bRaw)
							{
								for (i = (IMAGE_HEIGHT - gpImageHeight[cnt]) / 2; 
									i < gpImageHeight[cnt] + (IMAGE_HEIGHT - gpImageHeight[cnt]) / 2; 
									i++)
								{
									IndxDest = IMAGE_WIDTH * i  + (IMAGE_WIDTH - gpImageWidth[cnt]) / 2;
									for (j = (IMAGE_WIDTH - gpImageWidth[cnt]) / 2;
										j < gpImageWidth[cnt] + (IMAGE_WIDTH - gpImageWidth[cnt]) / 2;
										j++)
									{
										gpImage[IndxDest++] = gpAckDataBuf[IndxSrc++];
									}
								}
							}
							else
							{
								for (i = ((IMAGE_HEIGHT - gpImageHeight[cnt]) / 4); 
									i < (gpImageHeight[cnt] / 2) + ((IMAGE_HEIGHT - gpImageHeight[cnt]) / 4); 
									i++)
								{
									IndxDest = (IMAGE_WIDTH / 2) * i + (IMAGE_WIDTH - gpImageWidth[cnt]) / 4;
									for (j = ((IMAGE_WIDTH - gpImageWidth[cnt]) / 4) / 2;
										j < ((gpImageWidth[cnt] / 2) + ((IMAGE_WIDTH - gpImageWidth[cnt]) / 4)) / 2;
										j++)
									{
										gpImage[IndxDest++] = gpAckDataBuf[IndxSrc] & 0xF0;
										gpImage[IndxDest++] = (gpAckDataBuf[IndxSrc++] << 4) & 0xF0;
									}
								}
							}
							break;
						}
					}
					if (img_size == 80 * 80)
					{
						for (i = 0; i < 80; i++)
						{
							IndxDest = (80 + i) * 240 + 80;
							for (j = 0; j < 80; j++)
							{
								gpImage[IndxDest ++] = gpAckDataBuf[IndxSrc ++];
							}
						}
						m_btnBmp.m_dwWidth = 240;
						m_btnBmp.m_dwHeight = 240;
						m_btnBmp.m_pImage = gpImage;
						m_btnBmp.Invalidate();
					}
					else
					{
						if (bRaw)
						{
							m_btnBmp.m_dwWidth = IMAGE_WIDTH;
							m_btnBmp.m_dwHeight = IMAGE_HEIGHT;
						}
						else
						{
							m_btnBmp.m_dwWidth = IMAGE_WIDTH / 2;
							m_btnBmp.m_dwHeight = IMAGE_HEIGHT / 2;
						}
						m_btnBmp.m_pImage = gpImage;
						m_btnBmp.Invalidate();
					}
				}
				strcpy(strShow, "ָƲɼɹ");	
				break;

			case ST_TIMEOUT:
				strcpy(strShow, "ָƲɼʱ");
				break;
			default:
				strcpy(strShow, "ָƲɼʧ");
				break;
			}
			break;

		case ACK_FROM_VALUE_DB:
			switch (gpAckDataBuf[4])
			{
			case ST_SUCCESS:
				strcpy(strShow, "ɹ");

				UpdateData (true);
				if (m_bIDEnc2 && gnFeaIndx >= gnFeaCnt)
				{
					DWORD dwID;
					char  str1[10];
					dwID = GetParm (1) << 8;
					dwID += GetParm (2);

					dwID ++;
					
					itoa ((dwID >> 8) & 0xFF, str1, 16);
					m_editParm1.SetWindowText (str1);
					
					itoa (dwID & 0xFF, str1, 16);
					m_editParm2.SetWindowText (str1);

					OnChangeParm1 ();
				}
				break;
			default:
				strcpy(strShow, "ʧ");
				if (gbBatch)
				{
					MessageBox ("ʧ!");
					gnFeaIndx = gnFeaCnt;
				}
				break;

			case ST_USER_OCCUPIED:
				strcpy(strShow, "ûѴ");
				if (gbBatch)
				{
					itoa (gpIDBuf[gnFeaIndx] >> 16, str1, 10);
					MessageBox ("û" + CString(str1) + "Ѵ!");
					gnFeaIndx = gnFeaCnt;
				}
				break;

			case ST_FULL:
				strcpy(strShow, "ݿ޷û");
				if (gbBatch)
				{
					MessageBox ("ݿ޷û!");
					gnFeaIndx = gnFeaCnt;
				}
				break;
			}
			break;
				
		case ACK_FROM_VERIFY:
		case ACK_FROM_VERIFY_2:
			switch (gpAckDataBuf[4])
			{
			case ST_SUCCESS:
				strcpy(strShow, "ָƱȶԳɹ");
				break;		
			default:
				strcpy(strShow, "ָƱȶʧ");
				break;
			}
			break;

		case ACK_FROM_VERIFY_DB:
			switch (gpAckDataBuf[4])
			{
			case ST_SUCCESS:
				strcpy(strShow,"ָƱȶԳɹ");
				break;
			case ST_NO_USER:
				strcpy(strShow, "޴û");
				break;
			default:
				strcpy(strShow,"ָƱȶʧ");
				break;
			}
			break;		
							
		case ACK_FROM_IDENTIFY_DB:
			nUserID = gpAckDataBuf[2] * 256 + gpAckDataBuf[3];
			itoa(nUserID, str1, 10);
			switch (gpAckDataBuf[4])
			{
			case ST_NO_USER:
				strcpy(strShow,"ƥָ");
				break;									
			default:
				strcpy(strShow, str1);
				strcat(strShow, "ûȶԳɹ");
				break;
			}
			break;
			
		case ACK_TO_VALUE_DB://ûȡֵ
			if (gnLenAck == 207)
			{	
				strcpy(strShow,"ֵϴɹ");
			}
			else
			{
				if (gpAckDataBuf[4] == ST_NO_USER)
				{
					strcpy(strShow,"޴û");
				}
				else
				{
					strcpy(strShow,"ֵϴʧ");
				}
			}
			break;
				
		case ACK_GET_VALUE:			
			m_nCapTime = 700 + (GetTickCount() % 200);
			UpdateData (false);

			if (gnLenAck == 207)
			{
				strcpy(strShow, "ֵϴɹ");
			}
			else if (gpAckDataBuf[4] == ST_TIMEOUT)
			{
				strcpy(strShow, "ָƲɼʱ");
			}
			else
			{
				strcpy(strShow, "ֵϴʧ");
			}
			break;
				
		case ACK_SET_REG:
			if (gpAckDataBuf[4] == ST_SUCCESS)
			{
				char str[10];
				itoa(gpAckDataBuf[3], str, 16);
				strcpy(strShow, "ǰδ˼ĴֵΪ0x");
				strcat(strShow, str);
			}
			break;
			
		case ACK_GET_VERSION:
			if (gpAckDataBuf[4] == ST_SUCCESS)
			{
				int  len;
				int  indx = 0;
				char str[10];

				strcpy (strShow, "汾:");
				indx = strlen (strShow);

				strShow[indx++] = 0x0D;
				strShow[indx++] = 0x0A;

				for (i = 9; i < gnLenAck - 2; i++)
				{
					strShow[indx++] = gpAckDataBuf[i];
				}
				/*for (i = 0; i < 1016; i++)
				{
					if (gpAckDataBuf[9 + i] == 0x0) break;
					strShow[indx++] = gpAckDataBuf[9 + i];
				}
				*/
				strShow[indx++] = '\0';
			}				
			break;
			
		case ACK_TEST_COMM:
			switch (gpAckDataBuf[4])
			{
			case ST_SUCCESS:
				strcpy(strShow, "ͨųɹ");
				break;
			default:
				strcpy(strShow,"ͨʧ");
				break;
			}
			break;

		case ACK_GET_LUM:
			if (gpAckDataBuf[4] == ST_SUCCESS)
			{
				char str[10];
				/*if (gpAckDataBuf[2] == 1)
				{
					strcpy (strShow, "ͷ");
				}
				else if (gpAckDataBuf[2] == 2)
				{
					strcpy (strShow, "Žͷ");
				}
				else if (gpAckDataBuf[2] == 3)
				{
					strcpy (strShow, "ͷ");
				}
				else
				{
					strcpy (strShow, "ͷ");
				}
				*/
				strcpy (strShow, "ɹ");
				itoa(gpAckDataBuf[3], str, 10);
				strcat(strShow, " ֵΪ");
				strcat(strShow, str);
			}
			break;
		case ACK_LUM_ADJUST:
			if (gpAckDataBuf[4] == ST_SUCCESS)
			{
				char str[10];
				strcpy(strShow, "Уɹ");
			}
			break;
		case ACK_SET_MATCH_LEVEL:
			if (gpAckDataBuf[4] == ST_SUCCESS)
			{
				char str[10];
				itoa(gpAckDataBuf[3], str, 16);
				strcpy(strShow, "ǰαȶԵȼΪ");
				strcat(strShow, str);
			}
			break;

		case ACK_SET_ENROLL_MODE:
			if (gpAckDataBuf[4] == ST_SUCCESS)
			{
				char str[10];
				itoa(gpAckDataBuf[3], str, 16);
				strcpy(strShow, "ǰֵΪ");
				strcat(strShow, str);
			}

			break;

		case ACK_GET_USER_INFO:
			if (gpAckDataBuf[4] == ST_SUCCESS)
			{
				int  userCnt;
				int  userID, userRole;
				int  indx, indxShow;
				char str[10], lnEnd[10] = {0x0D, 0x0A, 0};
				
				userCnt = gpAckDataBuf[9] * 256 + gpAckDataBuf[10];
				itoa (userCnt, str, 10);
				
				strcpy (strShow, "ȡ");
				strcat (strShow, str);
				strcat (strShow, "û");
				
				strcat (strShow, lnEnd);

				indxShow = strlen(strShow);

				indx = 11;
				for (i = 0; i < userCnt; i++)
				{
					userID = gpAckDataBuf[indx] * 256 + gpAckDataBuf[indx + 1];
					userRole = gpAckDataBuf[indx + 2];
					
					itoa (i + 1, str, 10);
					strcat (strShow, str);
					strcat (strShow, ":û = ");
					itoa (userID, str, 10);
					strcat (strShow, str);
					strcat (strShow, " Ȩ = ");
					itoa (userRole, str, 10);
					strcat (strShow, str);

					strcat (strShow, lnEnd);
					indx += 3;					
				}
			}
			else
			{
				strcpy (strShow, "ʧ");
			}
			break;

		case ACK_SET_LP_MODE:
			if (gpAckDataBuf[4] == ST_SUCCESS)
			{
				strcpy (strShow, "ģ״̬Ӧκ");
			}
			else
			{
				strcpy (strShow, "ʧ");
			}
			break;

		case ACK_GET_ONE_RECORD:
			if (gpAckDataBuf[4] == ST_SUCCESS)
			{				
				DWORD bytes[8];
				char str1[10];
				DWORD dwRecNo;
				WORD  wID;
				WORD  wYear, wMonth, wDate;
				WORD  wHour, wMinute;
				WORD  wEvent;

				for (i = 0; i < 8; i++)
				{
					bytes[i] = (DWORD)gpAckDataBuf[9 + i];
				}
				for (i = 0; i < 8; i++)
				{
					if (bytes[i] != 0xFF) break;
				}
				if (i >= 8)
				{
					strcpy (strShow, "Ϊռ¼");
				}
				else
				{
					dwRecNo = (bytes[0] << 14) & 0x3FC000;
					dwRecNo += (bytes[1] << 6) & 0x3FC0;
					dwRecNo += (bytes[2] >> 2) & 0x3F;

					wID = (bytes[2] << 8) & 0x0300;
					wID += bytes[3];

					wYear = (bytes[4] >> 1) & 0x7F;
					wMonth = (bytes[4] << 3) & 0x08;
					wMonth += (bytes[5] >> 5) & 0x07;
					wDate = bytes[5] & 0x1F;

					wHour = (bytes[6] >> 2) & 0x3F;
					wMonth = (bytes[6] << 4) & 0x30;
					wMonth += (bytes[7] >> 4) & 0x0F;
					
					wEvent = bytes[7] & 0x0F;

					strcpy (strShow, "¼Ϊ");
					itoa (dwRecNo, str1, 10);
					strcat (strShow, str1);
					
					int len;
					len = strlen(strShow);
					strShow[len] = 0x0D;
					strShow[len + 1] = 0x0A;
					strShow[len + 2] = '\0';

					itoa (wID, str1, 10);

					switch (wEvent)
					{
					case 1:
						strcat (strShow, "ȶԳɹ"); 
						strcat (strShow, " IDΪ");
						strcat (strShow, str1);
						break;
					case 2:
						strcat (strShow, "Ա֤ɹ"); 
						strcat (strShow, " IDΪ");
						strcat (strShow, str1);
						break;
					case 3:
						strcat (strShow, "ӳɹ"); 
						strcat (strShow, " IDΪ");
						strcat (strShow, str1);
						break;
					case 4:
						strcat (strShow, "ɾûɹ"); 
						strcat (strShow, " IDΪ");
						strcat (strShow, str1);
						break;
					case 5:
						strcat (strShow, "ɾûɹ"); 
						strcat (strShow, " ȨΪ");
						strcat (strShow, str1);
						break;
					case 6:
						strcat (strShow, "ɾһûɹ");
						break;
					case 7:
						strcat (strShow, "ɾй߳ɹ"); 
						break;
					}
				}				
			}
			else 
			{
				strcpy (strShow, "ʧ");
			}
			break;

		case ACK_GET_NEW_RECORD:
			if (gpAckDataBuf[4] == ST_SUCCESS)
			{				
				DWORD bytes[8];
				char str1[10];
				WORD  wRecCnt;
				DWORD dwRecNo;
				WORD  wID;
				WORD  wYear, wMonth, wDate;
				WORD  wHour, wMinute;
				WORD  wEvent;
				int   len;

				wRecCnt = gpAckDataBuf[9] * 256 + gpAckDataBuf[10];
				itoa (wRecCnt, str1, 10);
				strcpy (strShow, "¼Ϊ");
				strcat (strShow, str1);

				len = strlen(strShow);
				strShow[len] = 0x0D;
				strShow[len + 1] = 0x0A;
				strShow[len + 2] = '\0';

				for (i = 0; i < wRecCnt; i++)
				{
					for (j = 0; j < 8; j++)
					{
						bytes[j] = (DWORD)gpAckDataBuf[11 + 8 * i + j];
					}
					
					dwRecNo = (bytes[0] << 14) & 0x3FC000;
					dwRecNo += (bytes[1] << 6) & 0x3FC0;
					dwRecNo += (bytes[2] >> 2) & 0x3F;

					wID = (bytes[2] << 8) & 0x0300;
					wID += bytes[3];

					wYear = (bytes[4] >> 1) & 0x7F;
					wMonth = (bytes[4] << 3) & 0x08;
					wMonth += (bytes[5] >> 5) & 0x07;
					wDate = bytes[5] & 0x1F;

					wHour = (bytes[6] >> 2) & 0x3F;
					wMonth = (bytes[6] << 4) & 0x30;
					wMonth += (bytes[7] >> 4) & 0x0F;
					
					wEvent = bytes[7] & 0x0F;

					itoa (i, str1, 10);
					strcat (strShow, "¼");
					strcat (strShow, str1);
					strcat (strShow, "");

					strcat (strShow, "¼Ϊ");
					itoa (dwRecNo, str1, 10);
					strcat (strShow, str1);
					len = strlen(strShow);
					strShow[len] = 0x0D;
					strShow[len + 1] = 0x0A;
					strShow[len + 2] = '\0';			
					strcat (strShow, "  ");

					itoa (wID, str1, 10);
						
					switch (wEvent)
					{
					case 1:
						strcat (strShow, "ȶԳɹ"); 
						strcat (strShow, " IDΪ");
						strcat (strShow, str1);
						break;
					case 2:
						strcat (strShow, "Ա֤ɹ"); 
						strcat (strShow, " IDΪ");
						strcat (strShow, str1);
						break;
					case 3:
						strcat (strShow, "ӳɹ"); 
						strcat (strShow, " IDΪ");
						strcat (strShow, str1);
						break;
					case 4:
						strcat (strShow, "ɾûɹ"); 
						strcat (strShow, " IDΪ");
						strcat (strShow, str1);
						break;
					case 5:
						strcat (strShow, "ɾûɹ"); 
						strcat (strShow, " ȨΪ");
						strcat (strShow, str1);
						break;
					case 6:
						strcat (strShow, "ɾһûɹ");
						break;
					case 7:
						strcat (strShow, "ɾй߳ɹ"); 
						break;
					}
					len = strlen(strShow);
					strShow[len] = 0x0D;
					strShow[len + 1] = 0x0A;
					strShow[len + 2] = '\0';
				}				
			}
			else 
			{
				strcpy (strShow, "ʧ");
			}
			break;

		case ACK_CLEAR_RECORD:
			if (gpAckDataBuf[4] == ST_SUCCESS)
			{
				strcpy (strShow, "ռ¼ɹ");
			}
			else
			{
				strcpy (strShow, "ʧ");
			}
			break;		
		}
		m_editAckInfo.SetWindowText(strShow);

		if (gnFeaIndx < gnFeaCnt)
		{
			gnFeaIndx ++;		
			
			if (gnFeaIndx < gnFeaCnt)
			{
				m_nBatchIndx = gnFeaIndx + 1;
				UpdateData (false);				
			
				OnCmdInter();
				gnLenAck = 0;
			}
		}
		else
		{
			gbBatch = FALSE;
		}

		//if reg start ok ,then reg second
		if (gpAckDataBuf[1] == ACK_REG_START_DB)
		{
			if (gpAckDataBuf[4] == ST_SUCCESS)
			{
				gbRegStart  = false;
				UpdateData (true);
				if (m_bTwice) 
				{
					if (m_bUpload) gpCmdDataBuf[1] = CMD_REG_UPLOAD_DB;
							  else gpCmdDataBuf[1] = CMD_REG_END_DB;
					
				}
				else
				{
					gpCmdDataBuf[1] = CMD_REG_SECOND_DB;
				}

				CmdRefresh();
				OnButtonCmd();
				gnLenAck = 0;
			}
			else
			{
				gbRegStart = true;
				CmdRefresh();
			}
		}
		if (gpAckDataBuf[1] == ACK_REG_SECOND_DB)
		{
			if (gpAckDataBuf[4] == ST_SUCCESS)
			{
				gbRegStart = false;
				if (m_bUpload) gpCmdDataBuf[1] = CMD_REG_UPLOAD_DB;
					      else gpCmdDataBuf[1] = CMD_REG_END_DB;							  
				CmdRefresh();
				OnButtonCmd();
				gnLenAck = 0;
			}
			else
			{
				gbRegStart = true;
				CmdRefresh();
			}
		}
		if (gpAckDataBuf[1] == ACK_REG_END_DB ||
			gpAckDataBuf[1] == ACK_REG_UPLOAD_DB)
		{
			gbRegStart = true;
			CmdRefresh();
		}
		//if ack data involve feature ,enable store button
		if (gpAckDataBuf[1] == ACK_GET_VALUE		||
			gpAckDataBuf[1] == ACK_TO_VALUE_DB	||
			gpAckDataBuf[1] == ACK_PROCESS_IMAGE ||
			gpAckDataBuf[1] == ACK_REG_UPLOAD_DB)
		{
			m_btnStoreFea.EnableWindow(true);
		}
		
		gnLenAck = 0;
	}	
	CDialog::OnTimer(nIDEvent);
}

BOOL CCommTestDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	Init();	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCommTestDlg::OnChangeParm1() 
{
	int nVal12, nVal1, nVal2;
	char pBuf[10];
	
	if (!m_bEditChange)
	{
		m_bEditChange = true;
		nVal1 = GetParm(1);
		nVal2 = GetParm(2);
		nVal12 = ((nVal1 << 8) & 0xFF00) + (nVal2 & 0xFF);	

		itoa(nVal12, pBuf, 16);
		m_editParm12.SetWindowText(pBuf);

		m_bEditChange = false;
	}

	CmdRefresh();	
}

void CCommTestDlg::OnChangeParm2() 
{
	int nVal12, nVal1, nVal2;
	char pBuf[10];
	
	if (!m_bEditChange)
	{
		m_bEditChange = true;
		nVal1 = GetParm(1);
		nVal2 = GetParm(2);
		nVal12 = ((nVal1 << 8) & 0xFF00) + (nVal2 & 0xFF);

		itoa(nVal12, pBuf, 16);
		m_editParm12.SetWindowText(pBuf);

		m_bEditChange = false;
	}

	CmdRefresh();
}

void CCommTestDlg::OnChangeParm3() 
{
	CmdRefresh();
}

void CCommTestDlg::OnChangeParm12() 
{
	int nVal12, nVal1, nVal2;
	char pBuf[10];
	
	if (!m_bEditChange)
	{
		m_bEditChange = true;

		nVal12 = GetParm(4);
		nVal1 = (nVal12 >> 8) & 0xFF;
		nVal2 = nVal12 & 0xFF;

		itoa(nVal1, pBuf, 16);
		m_editParm1.SetWindowText(pBuf);

		itoa(nVal2, pBuf, 16);
		m_editParm2.SetWindowText(pBuf);

		m_bEditChange = false;
	}

	CmdRefresh();	
}

bool CCommTestDlg::ReadFeature()
{
	//open feature data file
	CFile f;

	UpdateData (true);
	
	if (m_strFeaPath.GetLength() == 0)
	{
		AfxMessageBox("ѡֵļ");
		return false;
	}
	if (f.Open(m_strFeaPath, CFile::modeRead) == NULL)
	{
		AfxMessageBox ("޷ " + m_strFeaPath);
		return false;
	}
	//read data from file
	if (f.Read(&gpCmdDataBuf[12], sizeof(BYTE) * FEA_LEN) != sizeof(BYTE) * FEA_LEN)
	{		
		AfxMessageBox (" " + m_strFeaPath +" ļ");
		f.Close();
		return false;
	}
	f.Close();	
	if (m_b2FP)
	{
		if (f.Open(m_strFeaPath + ".fea", CFile::modeRead) == NULL)
		{
			AfxMessageBox("޷ " + m_strFeaPath + ".fea");
			return false;
		}
		if (f.Read(&gpCmdDataBuf[12 + FEA_LEN], sizeof(BYTE) * FEA_LEN) != sizeof(BYTE) * FEA_LEN)
		{		
			AfxMessageBox (" " + m_strFeaPath + ".fea" + " ļ");
			f.Close();
			return false;
		}
		f.Close();	
	}

	CmdRefresh();	
	return true;
}

void CCommTestDlg::OnRadioGetUserInfo() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioSetLpMode() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioSetEnrollMode() 
{
	CmdRefresh();	
}

void CCommTestDlg::UnlockEncode(BYTE *pSrc, BYTE *pDst, WORD nLenByte)
{
	int i, j;
	BYTE byData;

	for (i = 0; i < nLenByte; i++)
	{
		byData = pSrc[i];
		for (j = 0; j < 8; j++)
		{
			if ((byData & 0x01) != 0)
			{
				pDst[8 * i + j] = 0xFF;
			}
			else
			{
				pDst[8 * i + j] = 0;
			}
			byData >>= 1;
		}
	}
}
void CCommTestDlg::UnlockDecode(BYTE *pSrc, BYTE *pDst, WORD nLenByte)
{
	int i, j;
	BYTE byData;

	for (i = 0; i < nLenByte; i++)
	{
		byData = 0;
		for (j = 0; j < 8; j++)
		{
			byData >>= 1;
			if ((pSrc[8 * i + j] & 0x10) != 0)
			{				
				byData += 0x80;
			}
		}
		pDst[i] = byData;
	}
}



void CCommTestDlg::OnRadioGetOneRecord() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioGetNewRecord() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioClearRecord() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioSetTime() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnRadioGetTime() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnBtnMoveRight() 
{
	int i;

	UpdateData (true);
	gpCmdDataBuf[0] = CMD_HEAD;
	gpCmdDataBuf[1] = CMD_SET_REG;
	gpCmdDataBuf[2] = 0;
	gpCmdDataBuf[3] = 0x6A - m_nMoveRight;
	gpCmdDataBuf[4] = 0;
	gpCmdDataBuf[5] = 0;
	gpCmdDataBuf[7] = CMD_TAIL;

	BYTE byXor = 0;

	for (i = 1; i <= 5; i++)
	{
		byXor ^= gpCmdDataBuf[i];
	}
	gpCmdDataBuf[6] = byXor;

	OnButtonCmd ();
}

void CCommTestDlg::OnBtnMoveUp() 
{
	int i;

	UpdateData (true);
	gpCmdDataBuf[0] = CMD_HEAD;
	gpCmdDataBuf[1] = CMD_SET_REG;
	gpCmdDataBuf[2] = 1;
	gpCmdDataBuf[3] = 0x80 - m_nMoveUp;
	gpCmdDataBuf[4] = 0;
	gpCmdDataBuf[5] = 0;
	gpCmdDataBuf[7] = CMD_TAIL;

	BYTE byXor = 0;

	for (i = 1; i <= 5; i++)
	{
		byXor ^= gpCmdDataBuf[i];
	}
	gpCmdDataBuf[6] = byXor;

	OnButtonCmd();	
}

void CCommTestDlg::OnBtnLum() 
{
	gpCmdDataBuf[0] = 0xC0;
	gpCmdDataBuf[1] = 0x01;
	gpCmdDataBuf[2] = 0x00;
	gpCmdDataBuf[3] = 0x00;
	gpCmdDataBuf[4] = 0x00;
	gpCmdDataBuf[5] = 0x00;
	gpCmdDataBuf[6] = 0x00;
	gpCmdDataBuf[7] = 0x01;
	gpCmdDataBuf[8] = 0x0B;
	gpCmdDataBuf[9] = 0x00;
	gpCmdDataBuf[10] = 0x0D;
	gpCmdDataBuf[11] = 0xC0;

	TXCommand (gpCmdDataBuf, 12);
/*	int i;

	UpdateData (true);
	gpCmdDataBuf[0] = CMD_HEAD;
	gpCmdDataBuf[1] = CMD_SET_REG;
	gpCmdDataBuf[2] = 2;
	gpCmdDataBuf[3] = 0x0E + m_nLumEnc;
	gpCmdDataBuf[4] = 0;
	gpCmdDataBuf[5] = 0;
	gpCmdDataBuf[7] = CMD_TAIL;

	BYTE byXor = 0;

	for (i = 1; i <= 5; i++)
	{
		byXor ^= gpCmdDataBuf[i];
	}
	gpCmdDataBuf[6] = byXor;

	OnButtonCmd ();	
*/
}

void CCommTestDlg::OnCheckTwice() 
{
	gbRegStart = true;
	UpdateData (true);
	m_nType = RADIO_REG_DB;
	UpdateData (false);
	CmdRefresh();
}

void CCommTestDlg::OnCheckUpload() 
{
	gbRegStart = true;
	UpdateData (true);
	m_nType = RADIO_REG_DB;
	UpdateData (false);
	CmdRefresh();
}

void CCommTestDlg::OnCheckIdenc1() 
{
	gbRegStart = true;
	UpdateData (true);
	m_nType = RADIO_REG_DB;
	UpdateData (false);
	CmdRefresh();	
}

BYTE pData[8971] = 
{	
	0XF5, 0x24, 0x23, 0x00, 0x00, 0x00, 0x07, 0xF5, 0xF5, 0x22, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x21, 0x22, 0x22, 0x22, 0x11, 0x12, 0x22, 0x22, 0x21, 0x11, 0x12, 0x22, 0x21, 0x11, 0x22, 0x22, 0x22, 0x11, 0x12, 0x22, 0x22, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x20, 0x00, 0xC0, 0x00, 0x70, 0x00, 0xBF, 0x21, 0x22, 0x22, 0x11, 0x11, 0x22, 0x22, 0x22, 0x11, 0x22, 0x22, 0x22, 0x11, 0x22, 0x22, 0x22, 0x21, 0x12, 0x22, 0x22, 0x22, 0x21, 0x12, 0x22, 0x22, 0x22, 0x11, 0x22, 0x22, 0x21, 0x12, 0x12, 0x22, 0x22, 0x11, 0x11, 0x22, 0x22, 0x11, 0x11, 0x11, 0x12, 0x21, 0x11, 0x11, 0x11, 0x21, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x20, 0x00, 0xC0, 0x00, 0x70, 0x00, 0xBF, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x21, 0x11, 0x12, 0x22, 0x21, 0x11, 0x11, 0x22, 0x22, 0x11, 0x11, 0x12, 0x21, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x20, 0x00, 0xC0, 0x00, 0x70, 0x00, 0xBF, 0x22, 0x23, 0x22, 0x22, 0x23, 0x23, 0x22, 0x22, 0x22, 0x23, 0x33, 0x22, 0x22, 0x23, 0x33, 0x32, 0x22, 0x22, 0x33, 0x33, 0x22, 0x22, 0x23, 0x33, 0x32, 0x22, 0x23, 0x33, 0x32, 0x22, 0x22, 0x23, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x11, 0x11, 0x22, 0x22, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x04, 0x40, 0x0F, 0x40, 0x20, 0x44, 0xF4, 0xF0, 0x23, 0x32, 0x22, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x33, 0x32, 0x22, 0x22, 0x23, 0x33, 0x22, 0x22, 0x23, 0x32, 0x33, 0x22, 0x22, 0x22, 0x32, 0x22, 0x22, 0x22, 0x33, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x21, 0x11, 0x12, 0x22, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x20, 0x00, 0xC0, 0x00, 0x70, 0x00, 0xBF, 
	0x32, 0x23, 0x33, 0x23, 0x22, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33,
	0X33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x22, 0x23, 0x33, 0x22, 0x22, 0x22, 0x23, 0x32, 0x22, 0x21, 0x21, 0x12, 0x12, 0x21, 0x22, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x40, 0x0F, 0x40, 0x20, 0x44, 0xF4, 0xF0, 0x22, 0x22, 0x23, 0x33, 0x33, 0x33, 0x23, 0x23, 0x33, 0x33, 0x32, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x32, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x23, 0x33, 0x32, 0x22, 0x22, 0x23, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x21, 0x11, 0x11, 0x22, 0x21, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x04, 0x40, 0x0F, 0x40, 0x20, 0x44, 0xF4, 0xF0, 0x23, 0x33, 0x33, 0x32, 0x32, 0x33, 0x33, 0x22, 0x32, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x23, 0x23, 0x33, 0x33, 0x33, 0x33, 0x22, 0x22, 0x33, 0x33, 0x22, 0x22, 0x22, 0x22, 0x22, 0x11, 0x21, 0x22, 0x21, 0x11, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x03, 0x00, 0x0C, 0x00, 0x07, 0x00, 0x0B, 0xF0, 0x33, 0x33, 0x32, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x44, 0x43, 0x33, 0x33, 0x44, 0x44, 0x33, 0x44, 0x43, 0x33, 0x34, 0x44, 0x43, 0x33, 0x33, 0x44, 0x44, 0x33, 0x33, 0x33, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x32, 0x22, 0x22, 0x22, 0x22, 0x22, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x40, 0x0F, 0x40, 0x20, 0x44, 0xF4, 0xF0, 0x33, 0x22, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x23, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x34, 0x33, 0x23, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x32, 0x33, 0x33, 0x33, 0x32, 0x22, 0x23, 0x33, 0x32, 0x22, 0x32, 0x22, 0x11, 0x12, 0x11, 0x11, 0x11, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x03, 0x00, 0x0C, 0x00, 0x07, 0x00, 0x0B, 0xF0, 0x33, 0x33, 0x33, 0x33, 0x33, 0x43, 0x22, 0x33, 0x34, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33, 0x44, 0x43, 0x33, 0x33, 0x33, 0x43,
	0x33, 0x33, 0x34, 0x44, 0x44, 0x44, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33,
	0X33, 0x33, 0x33, 0x33, 0x23, 0x22, 0x22, 0x23, 0x22, 0x21, 0x22, 0x22, 0x22, 0x22, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x03, 0x00, 0x0C, 0x00, 0x07, 0x00, 0x0B, 0xF0, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x34, 0x43, 0x33, 0x33, 0x34, 0x33, 0x33, 0x43, 0x33, 0x33, 0x34, 0x33, 0x33, 0x33, 0x33, 0x44, 0x33, 0x33, 0x33, 0x33, 0x33, 0x34, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x23, 0x33, 0x22, 0x22, 0x22, 0x22, 0x11, 0x11, 0x12, 0x22, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x03, 0x00, 0x0C, 0x00, 0x07, 0x00, 0x0B, 0xF0, 0x33, 0x23, 0x23, 0x34, 0x43, 0x33, 0x33, 0x33, 0x33, 0x23, 0x33, 0x33, 0x33, 0x33, 0x44, 0x33, 0x33, 0x33, 0x34, 0x34, 0x33, 0x34, 0x33, 0x33, 0x44, 0x44, 0x43, 0x33, 0x33, 0x33, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x22, 0x22, 0x23, 0x33, 0x22, 0x12, 0x11, 0x11, 0x11, 0x22, 0x12, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x44, 0x00, 0xF4, 0x02, 0x04, 0x4F, 0x4F, 0x00, 0x33, 0x33, 0x43, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x34, 0x33, 0x23, 0x44, 0x44, 0x44, 0x34, 0x43, 0x44, 0x44, 0x44, 0x44, 0x43, 0x34, 0x44, 0x44, 0x44, 0x33, 0x44, 0x44, 0x44, 0x33, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x21, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x03, 0x00, 0x0C, 0x00, 0x07, 0x00, 0x0B, 0xF0, 0x33, 0x43, 0x33, 0x22, 0x23, 0x33, 0x33, 0x33, 0x34, 0x33, 0x33, 0x44, 0x33, 0x33, 0x33, 0x33, 0x34, 0x43, 0x23, 0x43, 0x33, 0x43, 0x34, 0x33, 0x33, 0x33, 0x44, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x23, 0x23, 0x23, 0x33, 0x32, 0x22, 0x12, 0x22, 0x22, 0x12, 0x21, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x44, 0x00, 0xF4, 0x02, 0x04, 0x4F, 0x4F, 0x00, 0x33, 0x33, 0x33, 0x34, 0x34, 0x43, 0x44, 0x44, 0x44, 0x43, 0x33, 0x43, 0x44, 0x44, 0x33, 0x43, 0x34, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x44, 0x44, 0x44, 0x33, 0x33, 0x33, 0x34, 0x44, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x32, 0x33, 0x33,
	0x22, 0x22, 0x22, 0x21, 0x22, 0x22, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22,
	0X22, 0x20, 0x44, 0x00, 0xF4, 0x02, 0x04, 0x4F, 0x4F, 0x00, 0x33, 0x33, 0x33, 0x33, 0x44, 0x33, 0x32, 0x32, 0x23, 0x34, 0x44, 0x43, 0x33, 0x34, 0x34, 0x44, 0x44, 0x44, 0x44, 0x34, 0x44, 0x44, 0x44, 0x34, 0x44, 0x43, 0x34, 0x44, 0x44, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x22, 0x11, 0x22, 0x22, 0x22, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x40, 0x00, 0xC0, 0x00, 0x70, 0x00, 0xBF, 0x0F, 0x32, 0x33, 0x33, 0x33, 0x33, 0x32, 0x23, 0x23, 0x23, 0x33, 0x34, 0x34, 0x33, 0x34, 0x44, 0x34, 0x44, 0x44, 0x44, 0x44, 0x34, 0x44, 0x44, 0x33, 0x44, 0x33, 0x44, 0x44, 0x34, 0x33, 0x33, 0x44, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x32, 0x33, 0x22, 0x11, 0x12, 0x22, 0x11, 0x11, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x44, 0x00, 0xF4, 0x02, 0x04, 0x4F, 0x4F, 0x00, 0x34, 0x44, 0x33, 0x33, 0x33, 0x33, 0x44, 0x44, 0x44, 0x44, 0x33, 0x34, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x32, 0x32, 0x22, 0x22, 0x22, 0x22, 0x11, 0x22, 0x22, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x44, 0x00, 0xC0, 0x00, 0x70, 0x00, 0xBF, 0x0F, 0x33, 0x23, 0x23, 0x33, 0x43, 0x33, 0x33, 0x33, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x34, 0x44, 0x44, 0x44, 0x34, 0x44, 0x44, 0x44, 0x43, 0x44, 0x43, 0x34, 0x44, 0x44, 0x34, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x32, 0x33, 0x33, 0x33, 0x22, 0x22, 0x21, 0x11, 0x11, 0x22, 0x12, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x44, 0x00, 0xC0, 0x00, 0x70, 0x00, 0xBF, 0x0F, 0x33, 0x44, 0x44, 0x44, 0x34, 0x43, 0x34, 0x43, 0x33, 0x34, 0x33, 0x45, 0x55, 0x44, 0x44, 0x44, 0x44, 0x45, 0x55, 0x44, 0x45, 0x44, 0x44, 0x34, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x40, 0x0F, 0x40, 0x20, 0x44, 0xF4, 0xF0,
	0x0F, 0x34, 0x44, 0x43, 0x34, 0x34, 0x43, 0x34, 0x44, 0x42, 0x33, 0x34,
	0X34, 0x43, 0x44, 0x44, 0x43, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x44, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x32, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x11, 0x22, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x44, 0x00, 0xC0, 0x00, 0x70, 0x00, 0xBF, 0x0F, 0x44, 0x32, 0x33, 0x44, 0x44, 0x44, 0x44, 0x33, 0x44, 0x44, 0x44, 0x44, 0x44, 0x33, 0x34, 0x45, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x45, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x34, 0x44, 0x33, 0x33, 0x33, 0x33, 0x33, 0x32, 0x22, 0x22, 0x22, 0x22, 0x21, 0x21, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x50, 0x00, 0x40, 0x20, 0x44, 0xF4, 0xF0, 0x0F, 0x43, 0x33, 0x33, 0x45, 0x43, 0x43, 0x44, 0x22, 0x32, 0x33, 0x44, 0x45, 0x55, 0x54, 0x44, 0x44, 0x55, 0x54, 0x54, 0x54, 0x44, 0x44, 0x45, 0x54, 0x44, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x33, 0x33, 0x44, 0x43, 0x33, 0x33, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x50, 0x00, 0x40, 0x20, 0x44, 0xF4, 0xF0, 0x0F, 0x22, 0x34, 0x43, 0x23, 0x33, 0x44, 0x44, 0x44, 0x33, 0x34, 0x33, 0x44, 0x33, 0x44, 0x44, 0x34, 0x44, 0x32, 0x34, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x44, 0x44, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x22, 0x22, 0x22, 0x21, 0x22, 0x22, 0x11, 0x11, 0x22, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x40, 0x0F, 0x40, 0x07, 0x00, 0x0B, 0xF0, 0xFA, 0x44, 0x55, 0x43, 0x34, 0x44, 0x44, 0x44, 0x44, 0x45, 0x44, 0x44, 0x44, 0x44, 0x44, 0x45, 0x54, 0x45, 0x53, 0x34, 0x55, 0x54, 0x45, 0x55, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x33, 0x34, 0x33, 0x33, 0x33, 0x33, 0x32, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x50, 0x00, 0xC0, 0x20, 0x44, 0xF4, 0xF0, 0x0F, 0x43, 0x34, 0x34, 0x44, 0x33, 0x33, 0x32, 0x33, 0x33, 0x44, 0x32, 0x33, 0x44, 0x44, 0x33, 0x44, 0x44, 0x44, 0x44, 0x44,
	0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x33, 0x33,
	0X44, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x32, 0x21, 0x11, 0x11, 0x11, 0x12, 0x22, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x04, 0x40, 0x0F, 0x40, 0x07, 0x00, 0x0B, 0xF0, 0xFA, 0x34, 0x34, 0x44, 0x33, 0x33, 0x34, 0x44, 0x44, 0x44, 0x44, 0x33, 0x23, 0x34, 0x55, 0x53, 0x45, 0x44, 0x44, 0x45, 0x44, 0x45, 0x55, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x44, 0x43, 0x33, 0x43, 0x33, 0x33, 0x33, 0x33, 0x32, 0x22, 0x22, 0x22, 0x22, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x40, 0x0F, 0x40, 0x07, 0x00, 0x0B, 0xF0, 0xFA, 0x34, 0x43, 0x33, 0x34, 0x44, 0x33, 0x24, 0x44, 0x43, 0x44, 0x45, 0x55, 0x54, 0x35, 0x54, 0x44, 0x45, 0x54, 0x45, 0x55, 0x44, 0x44, 0x45, 0x44, 0x44, 0x44, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x34, 0x33, 0x33, 0x33, 0x33, 0x32, 0x22, 0x22, 0x22, 0x22, 0x21, 0x22, 0x21, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x05, 0x00, 0x0C, 0x00, 0x04, 0x4F, 0x4F, 0x00, 0xF3, 0x34, 0x44, 0x44, 0x44, 0x33, 0x33, 0x34, 0x22, 0x33, 0x34, 0x32, 0x34, 0x44, 0x45, 0x43, 0x44, 0x44, 0x45, 0x54, 0x45, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x45, 0x44, 0x54, 0x44, 0x44, 0x44, 0x33, 0x44, 0x44, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x32, 0x22, 0x22, 0x22, 0x21, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x40, 0x0F, 0x40, 0x27, 0x00, 0x0B, 0xF0, 0xFA, 0x44, 0x45, 0x44, 0x33, 0x33, 0x45, 0x55, 0x33, 0x45, 0x55, 0x44, 0x34, 0x45, 0x55, 0x54, 0x55, 0x54, 0x55, 0x54, 0x44, 0x55, 0x55, 0x55, 0x55, 0x54, 0x45, 0x54, 0x44, 0x45, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x44, 0x44, 0x43, 0x44, 0x33, 0x32, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x06, 0x00, 0x0C, 0x00, 0x04, 0x4F, 0x4F, 0x00, 0xF3, 0x24, 0x43, 0x34, 0x34, 0x45, 0x44, 0x43, 0x44, 0x33, 0x33, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x54, 0x45, 0x53, 0x45, 0x43, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x33, 0x34, 0x44, 0x33, 0x33, 0x33, 0x33, 0x32, 
	0x22, 0x11, 0x12, 0x22, 0x22, 0x22, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22,
	0X22, 0x22, 0x06, 0x00, 0xF4, 0x02, 0x04, 0x00, 0xBF, 0x0F, 0xAA, 0x44, 0x54, 0x33, 0x44, 0x44, 0x34, 0x34, 0x44, 0x33, 0x33, 0x53, 0x34, 0x55, 0x44, 0x44, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x53, 0x44, 0x54, 0x54, 0x55, 0x55, 0x55, 0x55, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x33, 0x33, 0x32, 0x22, 0x22, 0x22, 0x22, 0x22, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x00, 0x0C, 0x00, 0x07, 0x4F, 0x4F, 0x00, 0xF3, 0x43, 0x23, 0x34, 0x42, 0x33, 0x45, 0x44, 0x45, 0x45, 0x44, 0x44, 0x34, 0x34, 0x45, 0x54, 0x45, 0x44, 0x45, 0x43, 0x44, 0x44, 0x45, 0x54, 0x54, 0x45, 0x54, 0x45, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33, 0x32, 0x22, 0x22, 0x22, 0x22, 0x21, 0x22, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x06, 0x00, 0xF4, 0x02, 0x04, 0x00, 0xBF, 0x0F, 0xAA, 0x33, 0x45, 0x53, 0x22, 0x54, 0x44, 0x42, 0x33, 0x32, 0x35, 0x55, 0x55, 0x44, 0x44, 0x55, 0x45, 0x55, 0x55, 0x55, 0x45, 0x55, 0x54, 0x54, 0x55, 0x45, 0x55, 0x55, 0x44, 0x45, 0x44, 0x55, 0x44, 0x44, 0x44, 0x43, 0x44, 0x44, 0x43, 0x44, 0x33, 0x33, 0x32, 0x22, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x06, 0x00, 0xF4, 0x02, 0x04, 0x00, 0xBF, 0x0F, 0xAA, 0x34, 0x44, 0x44, 0x44, 0x54, 0x34, 0x33, 0x45, 0x43, 0x34, 0x34, 0x44, 0x54, 0x54, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x45, 0x54, 0x55, 0x55, 0x55, 0x55, 0x55, 0x44, 0x45, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x33, 0x33, 0x33, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x44, 0x00, 0xC0, 0x00, 0x70, 0x04, 0xF0, 0x0F, 0x37, 0x44, 0x42, 0x34, 0x53, 0x23, 0x33, 0x34, 0x55, 0x44, 0x45, 0x44, 0x32, 0x45, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x55, 0x55, 0x55, 0x35, 0x45, 0x55, 0x45, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x33, 0x33, 0x33, 0x21, 0x12, 0x22, 0x22, 0x22, 0x21, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x06, 0x00, 0xF4, 0x02, 0x04, 0x40, 0xBF, 
	0x0F, 0xAA, 0x53, 0x33, 0x54, 0x33, 0x44, 0x44, 0x53, 0x34, 0x33, 0x34,
	0X55, 0x54, 0x52, 0x46, 0x55, 0x45, 0x53, 0x55, 0x34, 0x55, 0x55, 0x55, 0x65, 0x55, 0x55, 0x55, 0x55, 0x44, 0x44, 0x45, 0x54, 0x45, 0x55, 0x44, 0x44, 0x44, 0x34, 0x43, 0x33, 0x44, 0x33, 0x33, 0x22, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x44, 0x00, 0xF0, 0x00, 0x70, 0x04, 0xF0, 0x0F, 0x37, 0x43, 0x34, 0x42, 0x33, 0x54, 0x33, 0x34, 0x45, 0x43, 0x22, 0x45, 0x45, 0x34, 0x54, 0x55, 0x55, 0x53, 0x45, 0x34, 0x55, 0x45, 0x45, 0x55, 0x55, 0x45, 0x54, 0x54, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x33, 0x33, 0x33, 0x22, 0x22, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x44, 0x00, 0xF0, 0x00, 0x70, 0x04, 0xF0, 0x0F, 0x37, 0x35, 0x54, 0x33, 0x53, 0x23, 0x34, 0x55, 0x44, 0x55, 0x53, 0x44, 0x45, 0x55, 0x44, 0x55, 0x35, 0x55, 0x55, 0x64, 0x55, 0x56, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x45, 0x55, 0x55, 0x55, 0x55, 0x45, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x33, 0x32, 0x22, 0x22, 0x32, 0x22, 0x22, 0x22, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x70, 0x00, 0xC0, 0x20, 0x44, 0xF4, 0xF0, 0xFA, 0xA7, 0x45, 0x43, 0x34, 0x53, 0x33, 0x44, 0x43, 0x23, 0x44, 0x55, 0x53, 0x45, 0x35, 0x54, 0x44, 0x54, 0x45, 0x55, 0x55, 0x35, 0x44, 0x55, 0x55, 0x54, 0x55, 0x45, 0x54, 0x44, 0x45, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x33, 0x33, 0x33, 0x32, 0x21, 0x21, 0x22, 0x22, 0x21, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x44, 0x00, 0xF0, 0x00, 0x70, 0x00, 0xF0, 0x0F, 0x37, 0x45, 0x24, 0x45, 0x54, 0x55, 0x43, 0x34, 0x33, 0x55, 0x55, 0x55, 0x55, 0x44, 0x55, 0x55, 0x55, 0x56, 0x55, 0x56, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x45, 0x55, 0x55, 0x55, 0x54, 0x45, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x44, 0x44, 0x33, 0x33, 0x22, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x70, 0x00, 0xC0, 0x20, 0x44, 0xF4, 0xF0, 0xFA, 0xA7, 0x53, 0x43, 0x54, 0x44, 0x54, 0x44, 0x45, 0x54, 0x43, 0x43, 0x45, 0x55, 0x45, 0x45, 0x55, 0x55, 0x55, 0x55, 0x55, 
	0x55, 0x65, 0x55, 0x55, 0x55, 0x45, 0x45, 0x54, 0x45, 0x54, 0x45, 0x54,
	0X44, 0x54, 0x44, 0x44, 0x44, 0x34, 0x43, 0x33, 0x33, 0x33, 0x33, 0x21, 0x11, 0x22, 0x22, 0x22, 0x22, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x70, 0x00, 0xC0, 0x20, 0x44, 0xF4, 0xF0, 0xFA, 0xA7, 0x45, 0x55, 0x54, 0x55, 0x43, 0x45, 0x53, 0x34, 0x33, 0x43, 0x44, 0x55, 0x55, 0x54, 0x55, 0x45, 0x64, 0x56, 0x55, 0x65, 0x55, 0x25, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x45, 0x55, 0x54, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 0x33, 0x34, 0x33, 0x33, 0x22, 0x22, 0x32, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x70, 0x0F, 0x40, 0x07, 0x00, 0x0B, 0x00, 0xF3, 0x70, 0x44, 0x55, 0x54, 0x55, 0x55, 0x45, 0x44, 0x33, 0x55, 0x55, 0x44, 0x45, 0x54, 0x55, 0x55, 0x55, 0x56, 0x45, 0x65, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x44, 0x55, 0x54, 0x55, 0x54, 0x44, 0x44, 0x44, 0x34, 0x33, 0x33, 0x33, 0x32, 0x22, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x40, 0x00, 0xC0, 0x20, 0x44, 0xF4, 0xF0, 0xFA, 0xA7, 0x34, 0x54, 0x54, 0x45, 0x45, 0x54, 0x34, 0x45, 0x55, 0x56, 0x55, 0x45, 0x54, 0x45, 0x44, 0x54, 0x55, 0x34, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x55, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x44, 0x44, 0x34, 0x33, 0x32, 0x21, 0x11, 0x12, 0x22, 0x22, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x70, 0x0F, 0x40, 0x27, 0x00, 0x0B, 0x00, 0xF3, 0x70, 0x55, 0x55, 0x45, 0x45, 0x55, 0x44, 0x45, 0x53, 0x34, 0x54, 0x55, 0x45, 0x45, 0x55, 0x54, 0x56, 0x56, 0x55, 0x66, 0x66, 0x56, 0x66, 0x56, 0x55, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x45, 0x55, 0x54, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x33, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x40, 0x0C, 0x00, 0x04, 0x4F, 0x4F, 0x0F, 0xAA, 0x72, 0x45, 0x43, 0x35, 0x43, 0x55, 0x23, 0x55, 0x43, 0x33, 0x33, 0x45, 0x54, 0x35, 0x55, 0x55, 0x45, 0x55, 0x65, 0x55, 0x55, 0x65, 0x46, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x54, 0x45, 0x45, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 
	0x33, 0x32, 0x22, 0x11, 0x12, 0x21, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22,
	0X22, 0x22, 0x20, 0x80, 0x0F, 0x40, 0x27, 0x00, 0x0B, 0xF0, 0xF3, 0x70, 0x53, 0x43, 0x53, 0x34, 0x54, 0x45, 0x53, 0x55, 0x55, 0x65, 0x35, 0x56, 0x55, 0x65, 0x56, 0x56, 0x65, 0x65, 0x56, 0x55, 0x63, 0x66, 0x55, 0x65, 0x55, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x45, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x32, 0x22, 0x21, 0x22, 0x23, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x40, 0x0C, 0x00, 0x07, 0x4F, 0x4F, 0x0F, 0xAA, 0x72, 0x53, 0x34, 0x53, 0x35, 0x44, 0x45, 0x43, 0x45, 0x55, 0x55, 0x44, 0x55, 0x35, 0x55, 0x45, 0x54, 0x55, 0x55, 0x56, 0x55, 0x55, 0x55, 0x55, 0x55, 0x44, 0x55, 0x55, 0x55, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x43, 0x33, 0x33, 0x21, 0x11, 0x12, 0x22, 0x11, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x40, 0x0C, 0x00, 0x07, 0x4F, 0x4F, 0x0F, 0xAA, 0x72, 0x54, 0x55, 0x54, 0x55, 0x44, 0x65, 0x55, 0x65, 0x54, 0x56, 0x64, 0x66, 0x63, 0x46, 0x55, 0x54, 0x55, 0x65, 0x56, 0x54, 0x66, 0x66, 0x55, 0x56, 0x55, 0x55, 0x56, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x45, 0x54, 0x44, 0x44, 0x44, 0x43, 0x33, 0x33, 0x22, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x08, 0x00, 0x04, 0x02, 0x04, 0x00, 0xBF, 0x0F, 0x37, 0x00, 0x43, 0x45, 0x43, 0x45, 0x23, 0x54, 0x55, 0x65, 0x54, 0x54, 0x55, 0x54, 0x54, 0x54, 0x53, 0x65, 0x54, 0x56, 0x55, 0x55, 0x55, 0x55, 0x54, 0x54, 0x53, 0x55, 0x45, 0x55, 0x55, 0x45, 0x55, 0x55, 0x55, 0x45, 0x44, 0x44, 0x44, 0x44, 0x33, 0x33, 0x33, 0x32, 0x21, 0x11, 0x12, 0x12, 0x22, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x40, 0x0C, 0x00, 0x07, 0x4F, 0x4F, 0x0F, 0xAA, 0x72, 0x55, 0x46, 0x34, 0x65, 0x56, 0x65, 0x55, 0x55, 0x45, 0x56, 0x36, 0x55, 0x65, 0x54, 0x65, 0x56, 0x65, 0x56, 0x55, 0x65, 0x56, 0x65, 0x66, 0x55, 0x64, 0x66, 0x36, 0x65, 0x55, 0x55, 0x55, 0x55, 0x54, 0x55, 0x44, 0x44, 0x44, 0x44, 0x43, 0x44, 0x43, 0x32, 0x22, 0x12, 0x23, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x08, 0x00, 0x0C, 0x02, 0x04, 0x40, 0xBF, 
	0x0F, 0x37, 0x00, 0x33, 0x55, 0x44, 0x54, 0x45, 0x45, 0x45, 0x45, 0x45,
	0X53, 0x45, 0x65, 0x56, 0x54, 0x54, 0x55, 0x64, 0x56, 0x43, 0x65, 0x56, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x45, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x44, 0x33, 0x33, 0x22, 0x22, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x08, 0x00, 0xF4, 0x00, 0x70, 0x04, 0xF0, 0x0A, 0xA7, 0x23, 0x33, 0x55, 0x34, 0x54, 0x45, 0x44, 0x46, 0x55, 0x45, 0x55, 0x55, 0x65, 0x56, 0x65, 0x66, 0x33, 0x66, 0x66, 0x53, 0x56, 0x55, 0x65, 0x56, 0x55, 0x56, 0x55, 0x55, 0x55, 0x55, 0x55, 0x44, 0x55, 0x44, 0x45, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x00, 0x0C, 0x02, 0x04, 0x40, 0xBF, 0x0F, 0x37, 0x00, 0x54, 0x55, 0x45, 0x54, 0x46, 0x44, 0x45, 0x55, 0x54, 0x64, 0x44, 0x65, 0x46, 0x55, 0x56, 0x53, 0x65, 0x66, 0x55, 0x56, 0x65, 0x66, 0x56, 0x55, 0x65, 0x45, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x32, 0x22, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x09, 0x00, 0xF4, 0x00, 0x70, 0x04, 0xF0, 0x0F, 0xA7, 0x23, 0x43, 0x54, 0x45, 0x44, 0x45, 0x45, 0x54, 0x45, 0x55, 0x54, 0x35, 0x55, 0x56, 0x56, 0x66, 0x53, 0x66, 0x66, 0x66, 0x66, 0x55, 0x66, 0x66, 0x65, 0x56, 0x55, 0x53, 0x55, 0x55, 0x55, 0x45, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x33, 0x22, 0x22, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x09, 0x00, 0xF4, 0x00, 0x70, 0x04, 0xF0, 0x0F, 0xA7, 0x23, 0x54, 0x64, 0x56, 0x45, 0x46, 0x44, 0x54, 0x56, 0x54, 0x65, 0x46, 0x65, 0x56, 0x55, 0x46, 0x44, 0x56, 0x56, 0x66, 0x56, 0x65, 0x65, 0x55, 0x66, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x44, 0x44, 0x54, 0x44, 0x44, 0x44, 0x43, 0x33, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x44, 0x00, 0xC0, 0x00, 0x44, 0xFB, 0xF0, 0xFA, 0x70, 0x00, 0x44, 0x64, 0x46, 0x64, 0x46, 0x55, 0x54, 0x45, 0x55, 0x56, 0x54, 0x65, 0x54, 0x65, 0x56, 0x55, 0x56, 0x66, 
	0x66, 0x55, 0x65, 0x46, 0x56, 0x65, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55,
	0X55, 0x55, 0x45, 0x45, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x22, 0x22, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x09, 0x00, 0xF4, 0x00, 0x70, 0x04, 0xF0, 0x0F, 0xA7, 0x23, 0x34, 0x53, 0x35, 0x45, 0x56, 0x45, 0x55, 0x35, 0x55, 0x56, 0x55, 0x65, 0x56, 0x65, 0x56, 0x55, 0x56, 0x36, 0x66, 0x66, 0x66, 0x56, 0x64, 0x66, 0x66, 0x56, 0x66, 0x65, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x45, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x22, 0x22, 0x22, 0x22, 0x32, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x44, 0x00, 0xC0, 0x00, 0x44, 0xF4, 0xF0, 0xFA, 0x70, 0x00, 0x55, 0x54, 0x46, 0x44, 0x56, 0x45, 0x65, 0x34, 0x54, 0x64, 0x46, 0x65, 0x56, 0x64, 0x66, 0x65, 0x66, 0x55, 0x66, 0x66, 0x66, 0x66, 0x63, 0x66, 0x66, 0x55, 0x56, 0x55, 0x65, 0x54, 0x55, 0x45, 0x55, 0x44, 0x54, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x32, 0x22, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x90, 0x00, 0x40, 0x20, 0x00, 0x0B, 0x00, 0xF3, 0x72, 0x30, 0x55, 0x66, 0x56, 0x65, 0x56, 0x55, 0x56, 0x56, 0x66, 0x65, 0x66, 0x66, 0x65, 0x65, 0x56, 0x66, 0x67, 0x66, 0x67, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x65, 0x66, 0x55, 0x65, 0x55, 0x55, 0x54, 0x55, 0x44, 0x54, 0x44, 0x44, 0x44, 0x43, 0x33, 0x22, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x44, 0x00, 0xC0, 0x00, 0x44, 0xF4, 0xF0, 0xFA, 0x70, 0x00, 0x33, 0x54, 0x45, 0x55, 0x45, 0x53, 0x55, 0x53, 0x46, 0x65, 0x54, 0x55, 0x56, 0x65, 0x56, 0x65, 0x56, 0x53, 0x56, 0x55, 0x65, 0x66, 0x66, 0x66, 0x55, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x45, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x33, 0x32, 0x21, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x40, 0x00, 0x40, 0x20, 0x00, 0x0B, 0x00, 0xF3, 0x72, 0x30, 0x35, 0x64, 0x56, 0x64, 0x46, 0x54, 0x65, 0x65, 0x56, 0x65, 0x56, 0x65, 0x56, 0x66, 0x56, 0x66, 0x67, 0x54, 0x66, 0x65, 0x66, 0x66, 0x65, 0x66, 0x56, 0x66, 0x66, 0x66, 0x66, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x45, 0x44, 
	0x44, 0x43, 0x33, 0x32, 0x22, 0x22, 0x33, 0x22, 0x22, 0x22, 0x22, 0x22,
	0X22, 0x22, 0x20, 0x40, 0x00, 0x40, 0x20, 0x00, 0x0B, 0x00, 0xF3, 0x72, 0x30, 0x44, 0x53, 0x35, 0x54, 0x55, 0x54, 0x54, 0x55, 0x55, 0x54, 0x55, 0x53, 0x56, 0x54, 0x46, 0x65, 0x66, 0x53, 0x65, 0x63, 0x65, 0x56, 0x66, 0x56, 0x66, 0x56, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x54, 0x44, 0x54, 0x44, 0x44, 0x44, 0x44, 0x34, 0x33, 0x32, 0x22, 0x12, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0xA0, 0x0F, 0x40, 0x07, 0x0F, 0x4F, 0x0F, 0xAA, 0x00, 0x00, 0x43, 0x65, 0x45, 0x64, 0x54, 0x66, 0x62, 0x34, 0x45, 0x44, 0x66, 0x65, 0x56, 0x66, 0x56, 0x65, 0x56, 0x65, 0x66, 0x65, 0x66, 0x65, 0x66, 0x56, 0x66, 0x66, 0x66, 0x66, 0x56, 0x55, 0x65, 0x55, 0x55, 0x55, 0x54, 0x55, 0x54, 0x44, 0x44, 0x44, 0x44, 0x33, 0x22, 0x22, 0x22, 0x32, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0xA0, 0x0F, 0x40, 0x07, 0x0F, 0x4F, 0x0F, 0xAA, 0x00, 0x00, 0x43, 0x55, 0x45, 0x64, 0x54, 0x65, 0x62, 0x43, 0x44, 0x55, 0x65, 0x54, 0x65, 0x55, 0x56, 0x34, 0x65, 0x55, 0x66, 0x66, 0x66, 0x66, 0x65, 0x56, 0x65, 0x65, 0x55, 0x55, 0x45, 0x54, 0x55, 0x45, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x43, 0x33, 0x22, 0x11, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0xA0, 0x0F, 0x40, 0x07, 0x0F, 0x4F, 0x0F, 0xAA, 0x00, 0x00, 0x55, 0x66, 0x65, 0x65, 0x65, 0x63, 0x55, 0x55, 0x65, 0x66, 0x55, 0x55, 0x66, 0x65, 0x76, 0x45, 0x66, 0x65, 0x76, 0x56, 0x66, 0x57, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x56, 0x55, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x44, 0x44, 0x44, 0x33, 0x22, 0x22, 0x21, 0x23, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x24, 0x40, 0x0C, 0x00, 0x04, 0x40, 0xBF, 0x0F, 0x37, 0x23, 0x00, 0x42, 0x55, 0x45, 0x46, 0x44, 0x54, 0x35, 0x55, 0x55, 0x55, 0x56, 0x56, 0x55, 0x66, 0x66, 0x65, 0x66, 0x53, 0x66, 0x46, 0x66, 0x66, 0x66, 0x56, 0x55, 0x55, 0x65, 0x56, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 0x33, 0x33, 0x32, 0x21, 0x11, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0xA0, 0x0F, 0x40, 0x07, 0x0F, 0x4F, 
	0x0F, 0xAA, 0x00, 0x00, 0x44, 0x64, 0x56, 0x46, 0x55, 0x56, 0x55, 0x45,
	0X54, 0x45, 0x55, 0x66, 0x56, 0x64, 0x66, 0x45, 0x66, 0x66, 0x65, 0x65, 0x36, 0x66, 0x66, 0x66, 0x66, 0x65, 0x66, 0x56, 0x65, 0x56, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x55, 0x44, 0x44, 0x44, 0x43, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x24, 0x40, 0x0C, 0x00, 0x04, 0x4F, 0xBF, 0x0F, 0x37, 0x03, 0x00, 0x43, 0x54, 0x45, 0x45, 0x53, 0x56, 0x54, 0x45, 0x56, 0x44, 0x66, 0x65, 0x56, 0x46, 0x66, 0x56, 0x66, 0x56, 0x64, 0x65, 0x56, 0x46, 0x65, 0x66, 0x55, 0x64, 0x55, 0x55, 0x55, 0x55, 0x45, 0x55, 0x55, 0x45, 0x54, 0x45, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x22, 0x22, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x00, 0x04, 0x02, 0x00, 0x00, 0xF0, 0x0A, 0xA7, 0x20, 0x0C, 0x44, 0x54, 0x55, 0x55, 0x66, 0x55, 0x46, 0x65, 0x46, 0x45, 0x66, 0x56, 0x55, 0x56, 0x66, 0x66, 0x65, 0x56, 0x65, 0x66, 0x56, 0x66, 0x66, 0x66, 0x55, 0x65, 0x56, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x45, 0x54, 0x45, 0x44, 0x44, 0x44, 0x43, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x40, 0x0C, 0x00, 0x04, 0x4F, 0xBF, 0x0F, 0x37, 0x03, 0x00, 0x34, 0x63, 0x45, 0x55, 0x66, 0x34, 0x54, 0x65, 0x55, 0x56, 0x54, 0x35, 0x54, 0x56, 0x56, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x56, 0x66, 0x66, 0x56, 0x65, 0x55, 0x46, 0x55, 0x55, 0x45, 0x54, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x43, 0x32, 0x22, 0x21, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x00, 0x0C, 0x02, 0x00, 0x00, 0xF0, 0x0A, 0xA7, 0x20, 0x0C, 0x54, 0x54, 0x45, 0x66, 0x65, 0x54, 0x55, 0x64, 0x66, 0x66, 0x65, 0x66, 0x66, 0x66, 0x56, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x56, 0x65, 0x56, 0x46, 0x65, 0x46, 0x56, 0x66, 0x56, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x44, 0x54, 0x44, 0x44, 0x34, 0x32, 0x22, 0x21, 0x21, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x00, 0x0C, 0x02, 0x00, 0x00, 0xF0, 0x0A, 0xA7, 0x20, 0x0C, 0x55, 0x54, 0x55, 0x54, 0x55, 0x55, 0x54, 0x55, 0x55, 0x53, 0x65, 0x64, 0x56, 0x66, 0x56, 0x65, 0x66, 
	0x66, 0x66, 0x55, 0x66, 0x66, 0x62, 0x46, 0x56, 0x65, 0x55, 0x55, 0x54,
	0X55, 0x45, 0x55, 0x55, 0x45, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x33, 0x32, 0x22, 0x11, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x0B, 0x00, 0xF4, 0x00, 0x74, 0xF4, 0xF0, 0xFA, 0x70, 0x00, 0x08, 0x56, 0x56, 0x44, 0x65, 0x45, 0x46, 0x55, 0x45, 0x44, 0x45, 0x56, 0x55, 0x56, 0x66, 0x57, 0x75, 0x46, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x56, 0x66, 0x65, 0x66, 0x55, 0x65, 0x56, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x44, 0x54, 0x44, 0x44, 0x43, 0x33, 0x22, 0x22, 0x11, 0x13, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x0B, 0x00, 0xF4, 0x00, 0x70, 0xF4, 0xF0, 0xFA, 0x70, 0x00, 0x08, 0x66, 0x56, 0x55, 0x56, 0x54, 0x45, 0x66, 0x65, 0x44, 0x34, 0x45, 0x56, 0x63, 0x55, 0x56, 0x65, 0x56, 0x66, 0x56, 0x65, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x65, 0x55, 0x55, 0x55, 0x44, 0x55, 0x55, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x32, 0x22, 0x21, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x0B, 0x00, 0xF4, 0x00, 0x70, 0xF4, 0xF0, 0xFA, 0x70, 0x00, 0x08, 0x66, 0x66, 0x66, 0x56, 0x65, 0x55, 0x54, 0x66, 0x65, 0x46, 0x67, 0x66, 0x54, 0x66, 0x67, 0x65, 0x67, 0x56, 0x66, 0x64, 0x66, 0x46, 0x65, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x56, 0x45, 0x55, 0x55, 0x55, 0x55, 0x54, 0x44, 0x44, 0x44, 0x44, 0x43, 0x32, 0x22, 0x22, 0x22, 0x22, 0x32, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x00, 0xC0, 0x00, 0x44, 0x0B, 0xF0, 0xF3, 0x72, 0x30, 0xC0, 0x55, 0x55, 0x55, 0x45, 0x55, 0x55, 0x55, 0x34, 0x56, 0x66, 0x55, 0x65, 0x66, 0x66, 0x66, 0x65, 0x66, 0x65, 0x56, 0x54, 0x66, 0x56, 0x65, 0x56, 0x55, 0x65, 0x66, 0x56, 0x65, 0x55, 0x55, 0x55, 0x45, 0x54, 0x44, 0x44, 0x44, 0x44, 0x43, 0x34, 0x33, 0x32, 0x22, 0x22, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x0C, 0x00, 0xF4, 0x00, 0x70, 0xF4, 0xF0, 0xFA, 0x70, 0x00, 0x08, 0x65, 0x45, 0x65, 0x36, 0x66, 0x66, 0x66, 0x55, 0x66, 0x44, 0x55, 0x54, 0x66, 0x66, 0x66, 0x66, 0x66, 0x63, 0x76, 0x66, 0x76, 0x66, 0x66, 0x66, 0x56, 0x65, 0x66, 0x65, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x54, 0x44,
	0x44, 0x44, 0x44, 0x33, 0x22, 0x22, 0x12, 0x12, 0x33, 0x22, 0x22, 0x22,
	0X22, 0x22, 0x22, 0x04, 0x00, 0xC0, 0x00, 0x44, 0x0B, 0xF0, 0xF3, 0x72, 0x30, 0xC0, 0x55, 0x44, 0x46, 0x45, 0x56, 0x45, 0x56, 0x65, 0x64, 0x35, 0x56, 0x65, 0x56, 0x65, 0x46, 0x56, 0x65, 0x66, 0x65, 0x66, 0x66, 0x56, 0x66, 0x66, 0x66, 0x65, 0x65, 0x55, 0x55, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x44, 0x44, 0x44, 0x43, 0x33, 0x32, 0x22, 0x12, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x44, 0x00, 0xC0, 0x27, 0x00, 0x4F, 0x0F, 0xAA, 0x00, 0x00, 0x85, 0x55, 0x55, 0x45, 0x55, 0x55, 0x63, 0x54, 0x65, 0x46, 0x65, 0x66, 0x66, 0x66, 0x65, 0x26, 0x56, 0x54, 0x66, 0x65, 0x46, 0x66, 0x56, 0x66, 0x66, 0x66, 0x65, 0x66, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x44, 0x44, 0x44, 0x33, 0x32, 0x22, 0x12, 0x11, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x0C, 0x00, 0xF0, 0x00, 0x44, 0x0B, 0xF0, 0xF3, 0x72, 0x30, 0xC0, 0x66, 0x56, 0x66, 0x66, 0x55, 0x66, 0x55, 0x44, 0x56, 0x55, 0x66, 0x66, 0x66, 0x66, 0x36, 0x65, 0x43, 0x46, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x56, 0x64, 0x66, 0x55, 0x55, 0x55, 0x45, 0x55, 0x55, 0x55, 0x55, 0x45, 0x54, 0x44, 0x44, 0x44, 0x33, 0x32, 0x21, 0x11, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x44, 0x00, 0xC0, 0x20, 0x00, 0x0F, 0x0F, 0xAA, 0x00, 0x00, 0x85, 0x53, 0x55, 0x66, 0x65, 0x46, 0x66, 0x66, 0x55, 0x65, 0x55, 0x54, 0x56, 0x65, 0x66, 0x66, 0x65, 0x35, 0x66, 0x66, 0x76, 0x66, 0x66, 0x66, 0x66, 0x56, 0x65, 0x66, 0x55, 0x65, 0x55, 0x65, 0x55, 0x54, 0x54, 0x44, 0x44, 0x54, 0x44, 0x44, 0x44, 0x43, 0x32, 0x22, 0x11, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0xC0, 0x0F, 0x40, 0x07, 0x4F, 0x4F, 0x0F, 0x37, 0x23, 0x0C, 0x0F, 0x55, 0x65, 0x56, 0x66, 0x44, 0x65, 0x55, 0x66, 0x65, 0x55, 0x65, 0x65, 0x56, 0x45, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x55, 0x66, 0x56, 0x65, 0x56, 0x55, 0x65, 0x55, 0x55, 0x55, 0x55, 0x54, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x32, 0x22, 0x11, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x44, 0x00, 0xC0, 0x20, 0x00, 0x0F, 
	0x00, 0xAA, 0x00, 0x00, 0x85, 0x55, 0x55, 0x55, 0x55, 0x64, 0x55, 0x65,
	0X64, 0x66, 0x66, 0x65, 0x55, 0x55, 0x65, 0x55, 0x65, 0x46, 0x66, 0x66, 0x66, 0x66, 0x66, 0x55, 0x65, 0x56, 0x55, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x32, 0x21, 0x11, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0xC0, 0x0F, 0x40, 0x07, 0x4F, 0x4F, 0x0F, 0x37, 0x03, 0x0C, 0x0F, 0x65, 0x56, 0x66, 0x66, 0x56, 0x65, 0x65, 0x65, 0x56, 0x54, 0x54, 0x45, 0x66, 0x56, 0x66, 0x66, 0x56, 0x66, 0x56, 0x66, 0x66, 0x67, 0x66, 0x66, 0x66, 0x56, 0x65, 0x65, 0x55, 0x55, 0x45, 0x55, 0x55, 0x55, 0x54, 0x45, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x22, 0x22, 0x11, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0xD0, 0x0C, 0x00, 0x04, 0x40, 0xB0, 0x0F, 0xA7, 0x20, 0x08, 0x5C, 0x54, 0x56, 0x65, 0x66, 0x46, 0x64, 0x45, 0x56, 0x35, 0x55, 0x35, 0x66, 0x66, 0x55, 0x65, 0x64, 0x56, 0x56, 0x56, 0x55, 0x56, 0x66, 0x66, 0x66, 0x56, 0x65, 0x65, 0x55, 0x55, 0x45, 0x55, 0x55, 0x55, 0x54, 0x54, 0x44, 0x44, 0x44, 0x44, 0x43, 0x43, 0x32, 0x22, 0x22, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x40, 0x0F, 0x40, 0x07, 0x0F, 0x4F, 0x0F, 0x37, 0x03, 0x0C, 0x0F, 0x64, 0x65, 0x63, 0x56, 0x56, 0x65, 0x46, 0x56, 0x44, 0x56, 0x56, 0x66, 0x55, 0x66, 0x66, 0x65, 0x66, 0x66, 0x56, 0x66, 0x56, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x54, 0x44, 0x44, 0x33, 0x32, 0x22, 0x22, 0x21, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0xD0, 0x0F, 0x00, 0x04, 0x40, 0xBF, 0x0F, 0xA7, 0x20, 0x08, 0x5C, 0x64, 0x45, 0x63, 0x55, 0x55, 0x55, 0x54, 0x44, 0x45, 0x45, 0x55, 0x55, 0x66, 0x55, 0x54, 0x66, 0x66, 0x66, 0x66, 0x55, 0x65, 0x56, 0x66, 0x65, 0x66, 0x56, 0x65, 0x66, 0x55, 0x55, 0x55, 0x55, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x33, 0x33, 0x22, 0x22, 0x11, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x24, 0x40, 0x0C, 0x02, 0x00, 0x04, 0xF0, 0xFA, 0x70, 0x00, 0x00, 0xF4, 0x65, 0x55, 0x66, 0x45, 0x66, 0x65, 0x56, 0x64, 0x46, 0x65, 0x56, 0x66, 0x66, 0x56, 0x64, 0x66,
	0x66, 0x66, 0x76, 0x54, 0x76, 0x66, 0x66, 0x53, 0x66, 0x66, 0x66, 0x66,
	0X55, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x44, 0x44, 0x44, 0x44, 0x32, 0x32, 0x22, 0x22, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0xD0, 0x0F, 0x00, 0x04, 0x40, 0xBF, 0x0F, 0xA7, 0x20, 0x08, 0x5C, 0x55, 0x45, 0x46, 0x44, 0x56, 0x65, 0x55, 0x65, 0x66, 0x66, 0x66, 0x66, 0x56, 0x66, 0x63, 0x66, 0x65, 0x56, 0x56, 0x55, 0x65, 0x65, 0x65, 0x65, 0x66, 0x56, 0x55, 0x56, 0x55, 0x55, 0x55, 0x54, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x32, 0x11, 0x11, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x24, 0x40, 0x0C, 0x02, 0x00, 0x04, 0xF0, 0xFA, 0x70, 0x00, 0x00, 0xF4, 0x56, 0x55, 0x55, 0x64, 0x54, 0x64, 0x56, 0x65, 0x46, 0x65, 0x55, 0x56, 0x65, 0x66, 0x65, 0x66, 0x65, 0x66, 0x55, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x56, 0x65, 0x56, 0x55, 0x56, 0x55, 0x55, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x32, 0x21, 0x21, 0x12, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x00, 0xF4, 0x00, 0x74, 0xF4, 0xF0, 0xF3, 0x72, 0x30, 0xC0, 0xC9, 0x55, 0x65, 0x54, 0x56, 0x54, 0x56, 0x45, 0x54, 0x45, 0x65, 0x44, 0x45, 0x65, 0x66, 0x65, 0x56, 0x46, 0x65, 0x45, 0x66, 0x66, 0x66, 0x65, 0x66, 0x66, 0x66, 0x55, 0x65, 0x46, 0x55, 0x55, 0x55, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x32, 0x21, 0x21, 0x11, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x40, 0x0C, 0x02, 0x00, 0x00, 0xF0, 0xFA, 0xA0, 0x00, 0x08, 0xF4, 0x54, 0x66, 0x66, 0x66, 0x66, 0x66, 0x65, 0x43, 0x35, 0x64, 0x34, 0x46, 0x66, 0x66, 0x65, 0x66, 0x56, 0x66, 0x55, 0x66, 0x56, 0x66, 0x66, 0x76, 0x66, 0x66, 0x66, 0x65, 0x56, 0x55, 0x65, 0x55, 0x55, 0x55, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x32, 0x22, 0x21, 0x12, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x00, 0x04, 0x00, 0x70, 0xF4, 0xF0, 0xF3, 0x72, 0x30, 0xC0, 0xC9, 0x45, 0x65, 0x64, 0x55, 0x56, 0x66, 0x66, 0x66, 0x66, 0x66, 0x56, 0x66, 0x55, 0x65, 0x55, 0x66, 0x65, 0x65, 0x66, 0x66, 0x66, 0x65, 0x56, 0x66, 0x66, 0x66, 0x66, 0x64, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x54, 0x44, 
	0x44, 0x44, 0x44, 0x43, 0x32, 0x21, 0x21, 0x11, 0x21, 0x22, 0x22, 0x22,
	0X22, 0x22, 0x22, 0x0E, 0x00, 0xF0, 0x00, 0x44, 0x0B, 0x00, 0xFA, 0x70, 0x00, 0x85, 0x45, 0x64, 0x54, 0x46, 0x34, 0x56, 0x43, 0x65, 0x54, 0x46, 0x56, 0x55, 0x46, 0x56, 0x54, 0x55, 0x36, 0x65, 0x56, 0x56, 0x66, 0x66, 0x65, 0x56, 0x66, 0x56, 0x65, 0x66, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x32, 0x21, 0x11, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x40, 0x04, 0x00, 0x70, 0xF4, 0xF0, 0xF3, 0x72, 0x30, 0xC0, 0xC9, 0x66, 0x56, 0x66, 0x65, 0x66, 0x34, 0x66, 0x56, 0x66, 0x55, 0x55, 0x56, 0x66, 0x66, 0x52, 0x46, 0x66, 0x66, 0x66, 0x66, 0x67, 0x66, 0x66, 0x65, 0x66, 0x65, 0x66, 0x66, 0x66, 0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x22, 0x22, 0x21, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x0E, 0x00, 0xF0, 0x00, 0x44, 0x0B, 0x00, 0xFA, 0x70, 0x00, 0x85, 0x45, 0x55, 0x45, 0x56, 0x66, 0x66, 0x55, 0x56, 0x44, 0x65, 0x55, 0x55, 0x65, 0x55, 0x56, 0x53, 0x56, 0x66, 0x66, 0x65, 0x65, 0x65, 0x66, 0x66, 0x55, 0x65, 0x45, 0x55, 0x56, 0x55, 0x35, 0x55, 0x55, 0x44, 0x54, 0x44, 0x44, 0x44, 0x44, 0x33, 0x33, 0x33, 0x22, 0x21, 0x21, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x04, 0x00, 0xC0, 0x20, 0x00, 0x4F, 0x0F, 0xA7, 0x03, 0x0C, 0x0F, 0x92, 0x54, 0x66, 0x56, 0x56, 0x66, 0x65, 0x56, 0x65, 0x66, 0x66, 0x66, 0x66, 0x65, 0x65, 0x55, 0x67, 0x54, 0x66, 0x66, 0x66, 0x66, 0x66, 0x65, 0x66, 0x65, 0x65, 0x66, 0x56, 0x66, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x54, 0x44, 0x44, 0x43, 0x44, 0x33, 0x22, 0x21, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x0E, 0x00, 0xF4, 0x00, 0x44, 0x0B, 0xF0, 0xFA, 0x70, 0x00, 0x85, 0x45, 0x54, 0x55, 0x55, 0x55, 0x56, 0x66, 0x55, 0x55, 0x55, 0x45, 0x55, 0x56, 0x56, 0x56, 0x55, 0x36, 0x34, 0x66, 0x55, 0x66, 0x66, 0x66, 0x54, 0x66, 0x55, 0x56, 0x56, 0x55, 0x54, 0x55, 0x55, 0x54, 0x55, 0x44, 0x54, 0x45, 0x44, 0x44, 0x33, 0x33, 0x33, 0x32, 0x21, 0x11, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x0E, 0x00, 0xC0, 0x20, 0x00, 0x0F,
	0x0F, 0xA7, 0x03, 0x00, 0x0F, 0x92, 0x66, 0x66, 0x66, 0x56, 0x66, 0x66,
	0X66, 0x66, 0x55, 0x55, 0x55, 0x65, 0x66, 0x66, 0x66, 0x56, 0x46, 0x56, 0x65, 0x76, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x65, 0x65, 0x55, 0x55, 0x65, 0x55, 0x55, 0x45, 0x54, 0x45, 0x45, 0x44, 0x44, 0x43, 0x33, 0x32, 0x22, 0x22, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x44, 0x00, 0x40, 0x07, 0x0F, 0x4F, 0x0F, 0x37, 0x20, 0x0C, 0x5C, 0x5B, 0x65, 0x56, 0x66, 0x65, 0x54, 0x66, 0x65, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x56, 0x35, 0x56, 0x66, 0x66, 0x56, 0x66, 0x55, 0x66, 0x66, 0x66, 0x66, 0x66, 0x65, 0x56, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x55, 0x45, 0x44, 0x44, 0x44, 0x34, 0x33, 0x32, 0x22, 0x21, 0x11, 0x21, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x0F, 0x00, 0xC0, 0x20, 0x40, 0x0F, 0x0F, 0xA7, 0x03, 0x00, 0x0F, 0x92, 0x55, 0x46, 0x55, 0x66, 0x56, 0x55, 0x55, 0x56, 0x55, 0x56, 0x65, 0x64, 0x55, 0x65, 0x45, 0x66, 0x65, 0x55, 0x56, 0x56, 0x56, 0x65, 0x36, 0x55, 0x56, 0x66, 0x66, 0x56, 0x55, 0x55, 0x55, 0x55, 0x54, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x32, 0x22, 0x21, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x44, 0x00, 0x40, 0x27, 0x0F, 0x4F, 0x0F, 0x37, 0x20, 0x0C, 0x5C, 0x5B, 0x45, 0x66, 0x56, 0x56, 0x66, 0x66, 0x66, 0x56, 0x55, 0x55, 0x65, 0x54, 0x54, 0x66, 0x56, 0x66, 0x55, 0x66, 0x66, 0x66, 0x66, 0x54, 0x46, 0x56, 0x66, 0x65, 0x26, 0x56, 0x65, 0x66, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x54, 0x44, 0x44, 0x44, 0x43, 0x32, 0x22, 0x22, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x00, 0xC0, 0x27, 0x0F, 0x4F, 0x0F, 0x37, 0x23, 0x0C, 0x5C, 0x5B, 0x55, 0x45, 0x44, 0x55, 0x56, 0x66, 0x65, 0x55, 0x55, 0x45, 0x55, 0x55, 0x55, 0x66, 0x65, 0x66, 0x45, 0x66, 0x54, 0x65, 0x66, 0x56, 0x65, 0x55, 0x65, 0x63, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x44, 0x45, 0x44, 0x44, 0x44, 0x33, 0x33, 0x33, 0x32, 0x12, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x40, 0x0F, 0x40, 0x04, 0x40, 0xB0, 0x0F, 0xA7, 0x00, 0x08, 0xF4, 0x2F, 0x56, 0x56, 0x66, 0x55, 0x55, 0x56, 0x66, 0x56, 0x66, 0x66, 0x66, 0x56, 0x65, 0x66, 0x65, 
	0x66, 0x56, 0x66, 0x44, 0x66, 0x65, 0x76, 0x65, 0x66, 0x65, 0x55, 0x66,
	0X66, 0x65, 0x65, 0x55, 0x55, 0x55, 0x54, 0x44, 0x44, 0x44, 0x54, 0x44, 0x34, 0x33, 0x32, 0x22, 0x22, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x40, 0x0F, 0x40, 0x04, 0x40, 0xB0, 0x0F, 0xA7, 0x00, 0x08, 0xF4, 0x2F, 0x56, 0x54, 0x64, 0x56, 0x66, 0x56, 0x55, 0x45, 0x55, 0x56, 0x56, 0x65, 0x56, 0x65, 0x55, 0x66, 0x65, 0x53, 0x46, 0x66, 0x65, 0x66, 0x64, 0x66, 0x66, 0x66, 0x66, 0x55, 0x55, 0x55, 0x55, 0x55, 0x44, 0x44, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x33, 0x32, 0x21, 0x21, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x40, 0x0F, 0x40, 0x04, 0x4F, 0xBF, 0x0F, 0xA7, 0x00, 0x08, 0xF4, 0x2F, 0x44, 0x65, 0x65, 0x55, 0x66, 0x65, 0x65, 0x55, 0x66, 0x55, 0x55, 0x55, 0x66, 0x66, 0x54, 0x66, 0x66, 0x64, 0x66, 0x65, 0x56, 0x56, 0x56, 0x66, 0x55, 0x66, 0x56, 0x65, 0x55, 0x55, 0x55, 0x55, 0x54, 0x54, 0x44, 0x45, 0x44, 0x44, 0x43, 0x34, 0x33, 0x32, 0x21, 0x21, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0xF0, 0x0F, 0x00, 0x04, 0x00, 0xF0, 0xFA, 0x70, 0x30, 0xC0, 0xC9, 0xBD, 0x55, 0x56, 0x65, 0x56, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x65, 0x55, 0x55, 0x66, 0x66, 0x65, 0x56, 0x66, 0x66, 0x66, 0x55, 0x66, 0x66, 0x66, 0x66, 0x55, 0x55, 0x56, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x33, 0x22, 0x21, 0x21, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0xF0, 0x0F, 0x00, 0x04, 0x00, 0xF0, 0xFA, 0x70, 0x30, 0xC0, 0xC9, 0xBD, 0x55, 0x42, 0x55, 0x55, 0x55, 0x46, 0x55, 0x56, 0x65, 0x56, 0x56, 0x55, 0x55, 0x45, 0x65, 0x56, 0x55, 0x66, 0x45, 0x56, 0x56, 0x55, 0x66, 0x56, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x55, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 0x33, 0x33, 0x33, 0x32, 0x22, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x00, 0x0F, 0x00, 0x04, 0x00, 0xF0, 0xFA, 0x70, 0x30, 0xC0, 0xC9, 0xBD, 0x56, 0x64, 0x56, 0x66, 0x65, 0x56, 0x56, 0x55, 0x55, 0x54, 0x66, 0x56, 0x66, 0x66, 0x55, 0x67, 0x56, 0x55, 0x26, 0x66, 0x66, 0x66, 0x66, 0x46, 0x65, 0x65, 0x55, 0x55, 0x65, 0x55, 0x55, 0x55, 0x55, 0x54, 0x54, 0x44,
	0x44, 0x44, 0x44, 0x43, 0x34, 0x33, 0x22, 0x21, 0x11, 0x12, 0x22, 0x22,
	0X22, 0x22, 0x22, 0x20, 0x40, 0x0C, 0x02, 0x70, 0xF4, 0xF0, 0xF3, 0x72, 0x00, 0x85, 0x45, 0xFF, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x65, 0x55, 0x55, 0x55, 0x55, 0x66, 0x65, 0x66, 0x56, 0x66, 0x65, 0x54, 0x46, 0x56, 0x56, 0x54, 0x45, 0x55, 0x66, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x55, 0x55, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 0x33, 0x33, 0x22, 0x21, 0x21, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x24, 0x40, 0x04, 0x00, 0x74, 0x0B, 0x00, 0xAA, 0x00, 0x00, 0x0F, 0x92, 0xDE, 0x45, 0x55, 0x65, 0x55, 0x55, 0x55, 0x65, 0x66, 0x65, 0x66, 0x56, 0x55, 0x55, 0x45, 0x56, 0x66, 0x66, 0x66, 0x56, 0x66, 0x66, 0x55, 0x55, 0x55, 0x66, 0x55, 0x55, 0x65, 0x56, 0x55, 0x55, 0x55, 0x55, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 0x33, 0x33, 0x32, 0x22, 0x21, 0x12, 0x12, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x00, 0x0C, 0x02, 0x00, 0xF4, 0xF0, 0xF3, 0x72, 0x00, 0x85, 0x45, 0xFF, 0x55, 0x44, 0x55, 0x66, 0x66, 0x66, 0x54, 0x55, 0x54, 0x55, 0x54, 0x45, 0x65, 0x55, 0x55, 0x66, 0x66, 0x56, 0x66, 0x66, 0x66, 0x66, 0x56, 0x65, 0x66, 0x66, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x55, 0x54, 0x54, 0x44, 0x44, 0x44, 0x34, 0x33, 0x33, 0x32, 0x22, 0x21, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x24, 0x40, 0x04, 0x00, 0x74, 0xFB, 0xF0, 0xFA, 0x00, 0x00, 0x0F, 0x92, 0xDE, 0x45, 0x55, 0x55, 0x54, 0x54, 0x55, 0x55, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x56, 0x44, 0x55, 0x66, 0x65, 0x55, 0x56, 0x56, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x44, 0x54, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x33, 0x34, 0x33, 0x33, 0x31, 0x21, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x40, 0x04, 0x00, 0x74, 0xFB, 0xF0, 0xFA, 0x70, 0x00, 0x0F, 0x92, 0xDE, 0x44, 0x56, 0x55, 0x53, 0x56, 0x56, 0x55, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x55, 0x45, 0x55, 0x55, 0x66, 0x65, 0x55, 0x65, 0x66, 0x66, 0x66, 0x66, 0x66, 0x55, 0x55, 0x65, 0x55, 0x55, 0x55, 0x55, 0x54, 0x54, 0x44, 0x44, 0x44, 0x34, 0x33, 0x43, 0x32, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x00, 0xF4, 0x00, 0x40, 0x0F,
	0x0F, 0xA7, 0x03, 0x0C, 0x5C, 0x5B, 0xF4, 0x43, 0x45, 0x55, 0x55, 0x55,
	0X55, 0x45, 0x55, 0x55, 0x45, 0x55, 0x55, 0x32, 0x55, 0x56, 0x55, 0x56, 0x56, 0x63, 0x55, 0x55, 0x55, 0x64, 0x55, 0x55, 0x55, 0x55, 0x55, 0x45, 0x55, 0x54, 0x54, 0x44, 0x44, 0x44, 0x34, 0x43, 0x44, 0x44, 0x33, 0x32, 0x22, 0x21, 0x11, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x00, 0xF4, 0x00, 0x40, 0x0F, 0x0F, 0xA7, 0x03, 0x0C, 0x5C, 0x5B, 0xF4, 0x55, 0x45, 0x45, 0x45, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x54, 0x54, 0x33, 0x35, 0x55, 0x56, 0x55, 0x55, 0x55, 0x65, 0x55, 0x55, 0x55, 0x55, 0x55, 0x45, 0x55, 0x55, 0x55, 0x54, 0x44, 0x55, 0x55, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x33, 0x33, 0x22, 0x21, 0x22, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x04, 0x00, 0xF4, 0x00, 0x44, 0x0F, 0x0F, 0xA7, 0x03, 0x0C, 0x0C, 0x5B, 0xF4, 0x55, 0x55, 0x55, 0x45, 0x55, 0x55, 0x65, 0x55, 0x55, 0x66, 0x66, 0x65, 0x56, 0x56, 0x56, 0x56, 0x55, 0x66, 0x56, 0x65, 0x55, 0x65, 0x65, 0x55, 0x56, 0x66, 0x55, 0x55, 0x65, 0x55, 0x55, 0x55, 0x55, 0x54, 0x54, 0x44, 0x44, 0x44, 0x44, 0x34, 0x43, 0x32, 0x22, 0x22, 0x12, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x01, 0x00, 0xC0, 0x20, 0x00, 0x4F, 0x0F, 0x37, 0x20, 0x08, 0x54, 0x2F, 0xE5, 0x55, 0x45, 0x55, 0x44, 0x55, 0x55, 0x54, 0x54, 0x54, 0x45, 0x45, 0x55, 0x54, 0x53, 0x45, 0x34, 0x55, 0x55, 0x55, 0x55, 0x54, 0x35, 0x56, 0x44, 0x55, 0x55, 0x55, 0x55, 0x54, 0x45, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x44, 0x33, 0x33, 0x32, 0x22, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x04, 0x00, 0xC0, 0x07, 0x4F, 0xBF, 0x0F, 0xA0, 0x00, 0x00, 0xF9, 0xBD, 0x49, 0x55, 0x43, 0x45, 0x55, 0x55, 0x54, 0x66, 0x55, 0x54, 0x44, 0x54, 0x54, 0x55, 0x53, 0x55, 0x45, 0x55, 0x65, 0x55, 0x66, 0x55, 0x56, 0x55, 0x23, 0x55, 0x65, 0x55, 0x55, 0x55, 0x55, 0x45, 0x54, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x43, 0x43, 0x22, 0x22, 0x22, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x01, 0x00, 0xF0, 0x20, 0x00, 0x4F, 0x0F, 0x37, 0x20, 0x08, 0x54, 0x2F, 0xE5, 0x55, 0x55, 0x45, 0x45, 0x45, 0x55, 0x55, 0x55, 0x66, 0x55, 0x55, 0x55, 0x55, 0x55,
	0x55, 0x65, 0x55, 0x54, 0x56, 0x55, 0x55, 0x55, 0x65, 0x55, 0x55, 0x55,
	0X55, 0x55, 0x55, 0x55, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x33, 0x33, 0x22, 0x11, 0x21, 0x21, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x00, 0xC0, 0x27, 0x4F, 0xBF, 0x0F, 0xA0, 0x00, 0x00, 0xF9, 0xBD, 0x49, 0x44, 0x44, 0x45, 0x44, 0x54, 0x44, 0x55, 0x44, 0x44, 0x55, 0x54, 0x55, 0x55, 0x55, 0x45, 0x43, 0x55, 0x45, 0x55, 0x55, 0x55, 0x54, 0x45, 0x55, 0x55, 0x55, 0x44, 0x45, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x44, 0x43, 0x33, 0x33, 0x33, 0x22, 0x22, 0x22, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x01, 0x00, 0xC0, 0x27, 0x0F, 0xBF, 0x0F, 0xA7, 0x00, 0x00, 0xF9, 0x2D, 0x49, 0x55, 0x45, 0x45, 0x55, 0x55, 0x44, 0x45, 0x45, 0x55, 0x55, 0x53, 0x55, 0x55, 0x55, 0x56, 0x55, 0x55, 0x45, 0x65, 0x55, 0x55, 0x55, 0x55, 0x45, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x45, 0x44, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x43, 0x33, 0x22, 0x22, 0x21, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x44, 0x00, 0x40, 0x04, 0x40, 0xB0, 0xFA, 0x70, 0x30, 0xC5, 0xC5, 0xBF, 0x57, 0x44, 0x45, 0x44, 0x54, 0x45, 0x55, 0x55, 0x45, 0x55, 0x55, 0x54, 0x45, 0x55, 0x55, 0x54, 0x55, 0x55, 0x55, 0x55, 0x55, 0x45, 0x54, 0x55, 0x55, 0x45, 0x44, 0x55, 0x55, 0x44, 0x54, 0x54, 0x44, 0x44, 0x44, 0x44, 0x43, 0x44, 0x43, 0x33, 0x33, 0x33, 0x22, 0x22, 0x11, 0x11, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x44, 0x00, 0x40, 0x04, 0x40, 0xB0, 0xFA, 0x70, 0x30, 0xC5, 0xC5, 0xBF, 0x57, 0x44, 0x55, 0x45, 0x44, 0x44, 0x55, 0x55, 0x44, 0x45, 0x55, 0x55, 0x55, 0x54, 0x45, 0x54, 0x55, 0x55, 0x45, 0x55, 0x55, 0x55, 0x54, 0x55, 0x54, 0x55, 0x55, 0x55, 0x44, 0x45, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x34, 0x33, 0x33, 0x33, 0x32, 0x22, 0x22, 0x12, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x04, 0x00, 0x40, 0x04, 0x40, 0xB0, 0x0A, 0x70, 0x30, 0xC5, 0xC5, 0xBF, 0x57, 0x44, 0x55, 0x55, 0x54, 0x44, 0x54, 0x55, 0x54, 0x45, 0x55, 0x55, 0x55, 0x53, 0x45, 0x55, 0x55, 0x54, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 
	0x44, 0x43, 0x43, 0x43, 0x33, 0x32, 0x22, 0x22, 0x11, 0x11, 0x22, 0x22,
	0X22, 0x22, 0x22, 0x20, 0x40, 0x0F, 0x00, 0x04, 0x04, 0xF0, 0xF3, 0x72, 0x00, 0x8F, 0x42, 0xFE, 0x95, 0x43, 0x44, 0x44, 0x44, 0x54, 0x44, 0x45, 0x54, 0x44, 0x23, 0x54, 0x54, 0x54, 0x54, 0x54, 0x45, 0x44, 0x55, 0x44, 0x45, 0x55, 0x44, 0x54, 0x55, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x44, 0x43, 0x43, 0x33, 0x43, 0x33, 0x33, 0x33, 0x22, 0x21, 0x21, 0x21, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x20, 0x0C, 0x02, 0x70, 0xF4, 0xF0, 0xFA, 0x70, 0x00, 0x0C, 0x9B, 0xD4, 0x7D, 0x43, 0x44, 0x42, 0x44, 0x45, 0x45, 0x45, 0x54, 0x55, 0x55, 0x55, 0x44, 0x55, 0x55, 0x44, 0x45, 0x45, 0x55, 0x55, 0x55, 0x55, 0x44, 0x55, 0x54, 0x44, 0x55, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x33, 0x44, 0x43, 0x33, 0x34, 0x33, 0x33, 0x33, 0x22, 0x11, 0x12, 0x11, 0x21, 0x11, 0x11, 0x11, 0x11, 0x10, 0x20, 0x0C, 0x02, 0x00, 0xF4, 0xF0, 0xFA, 0x70, 0x00, 0x0F, 0x9B, 0xD4, 0x7D, 0x44, 0x44, 0x42, 0x44, 0x55, 0x45, 0x55, 0x44, 0x45, 0x44, 0x54, 0x55, 0x44, 0x44, 0x45, 0x55, 0x55, 0x45, 0x54, 0x55, 0x55, 0x45, 0x45, 0x44, 0x54, 0x55, 0x55, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x33, 0x33, 0x32, 0x12, 0x22, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x20, 0x0C, 0x02, 0x00, 0xF4, 0xF0, 0xFA, 0x70, 0x00, 0x0F, 0x9B, 0xD4, 0x7D, 0x44, 0x44, 0x43, 0x44, 0x44, 0x34, 0x44, 0x44, 0x43, 0x34, 0x32, 0x43, 0x44, 0x54, 0x44, 0x54, 0x44, 0x44, 0x44, 0x45, 0x44, 0x45, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x44, 0x34, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x21, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x20, 0x0F, 0x02, 0x00, 0xF4, 0xF0, 0xFA, 0x70, 0x00, 0x0F, 0x9B, 0xD4, 0x7D, 0x34, 0x44, 0x54, 0x44, 0x44, 0x44, 0x44, 0x55, 0x44, 0x44, 0x44, 0x54, 0x45, 0x44, 0x45, 0x44, 0x44, 0x44, 0x44, 0x44, 0x54, 0x44, 0x55, 0x44, 0x44, 0x45, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x44, 0x43, 0x33, 0x33, 0x33, 0x33, 0x11, 0x22, 0x22, 0x12, 0x12, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x20, 0x0C, 0x00, 0x74, 0xFB, 
	0x00, 0xA7, 0x03, 0x0C, 0x5C, 0x5F, 0xF5, 0x53, 0x34, 0x33, 0x44, 0x44,
	0X44, 0x44, 0x44, 0x44, 0x45, 0x44, 0x44, 0x44, 0x44, 0x43, 0x54, 0x44, 0x45, 0x55, 0x44, 0x44, 0x45, 0x44, 0x45, 0x55, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x34, 0x44, 0x33, 0x34, 0x33, 0x33, 0x22, 0x32, 0x12, 0x12, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22, 0x24, 0x40, 0x04, 0x00, 0x40, 0x0F, 0x0F, 0x37, 0x20, 0x08, 0xF4, 0x2D, 0xE9, 0xDD, 0x33, 0x32, 0x33, 0x33, 0x34, 0x44, 0x33, 0x44, 0x44, 0x33, 0x44, 0x43, 0x33, 0x44, 0x44, 0x34, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x44, 0x44, 0x33, 0x43, 0x43, 0x43, 0x43, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x32, 0x23, 0x22, 0x21, 0x11, 0x11, 0X11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x40, 0x04, 0x00, 0x40, 0x0F, 0x0F, 0x37, 0x20, 0x08, 0xF4, 0x2D, 0xE9, 0xDD, 0x44, 0x43, 0x34, 0x44, 0x34, 0x43, 0x44, 0x44, 0x34, 0x44, 0x33, 0x43, 0x44, 0x43, 0x44, 0x44, 0x34, 0x43, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x44, 0x33, 0x34, 0x43, 0x33, 0x43, 0x43, 0x33, 0x43, 0x33, 0x33, 0x33, 0x21, 0x21, 0x22, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x40, 0x04, 0x00, 0x40, 0x0F, 0x0F, 0x37, 0x20, 0x08, 0xF4, 0x2D, 0xE9, 0xDD, 0x33, 0x34, 0x34, 0x44, 0x34, 0x44, 0x33, 0x34, 0x44, 0x44, 0x44, 0x43, 0x33, 0x44, 0x44, 0x43, 0x43, 0x43, 0x44, 0x44, 0x44, 0x34, 0x44, 0x44, 0x44, 0x44, 0x44, 0x34, 0x44, 0x34, 0x34, 0x33, 0x33, 0x34, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33, 0x32, 0x22, 0x22, 0x21, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x20, 0x40, 0x04, 0x00, 0x44, 0x0F, 0x0F, 0x37, 0x20, 0x08, 0xF4, 0x2D, 0xE9, 0xDD, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x32, 0x33, 0x43, 0x33, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x23, 0x22, 0x22, 0x12, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x14, 0x00, 0xF0, 0x00, 0x00, 0x4F, 0x0F, 0xA7, 0x00, 0x00, 0xC9, 0xBF, 0x47, 0x3B, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x23, 0x33, 
	0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x43, 0x33, 0x33, 0x33, 0x33, 0x33,
	0X33, 0x33, 0x32, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x32, 0x23, 0x32, 0x21, 0x12, 0x21, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x14, 0x40, 0xF4, 0x00, 0x40, 0x4F, 0x0F, 0x37, 0x00, 0x00, 0xF9, 0xBD, 0x47, 0xDB, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x43, 0x33, 0x33, 0x34, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x34, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x34, 0x44, 0x33, 0x33, 0x33, 0x33, 0x33, 0x22, 0x22, 0x22, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22, 0x04, 0x00, 0xC0, 0x27, 0x0F, 0xBF, 0x0A, 0xA0, 0x30, 0xC5, 0xC5, 0xFF, 0x55, 0x3A, 0x5E, 0xF5,
};

void CCommTestDlg::OnCheck2fp() 
{
	gbRegStart = true;
	UpdateData (true);
	m_nType = RADIO_FROM_VERIFY;
	UpdateData (false);
	CmdRefresh();	
}

void CCommTestDlg::OnCheckImgRaw() 
{
	gbRegStart = true;
	UpdateData (true);
	m_nType = RADIO_GET_IMAGE;
	UpdateData (false);
	CmdRefresh();	
}

void CCommTestDlg::OnCheckIdenc2() 
{
	gbRegStart = true;
	UpdateData (true);
	m_nType = RADIO_FROM_VALUE_DB;
	UpdateData (false);
	CmdRefresh();	
}

void CCommTestDlg::OnLumAdjust() 
{
	CmdRefresh();	
}

void CCommTestDlg::OnBtnBatch() 
{
	char pDirName[200];
	char pPathName[200];
	char strSub[10];
	char str[200];
	HANDLE hSearch;
	bool bSearch;
	short result;
	WORD uLen;
	DWORD lID;
	WIN32_FIND_DATA fd;
	DWORD tMatch;
	BYTE byXor;
	CFile f;
	char ch;
	int  i;
	
	GetModuleFileName (NULL, pDirName, 200);
	for (i = strlen (pDirName) - 1; i >= 0; i --)
	{
		if (pDirName[i] == '\\') break;
	}
	pDirName[i + 1] = 0;

	strcpy (pPathName, pDirName);
	strcat (pPathName, "*.fea");
	
	gnFeaCnt = 0;
	hSearch = FindFirstFile (pPathName, &fd);
	if ((DWORD)hSearch == 0xFFFFFFFF)
	{
		MessageBox ("ֵļ!");
		return;
	}
	
	while (1)
	{
		if (gnFeaCnt <= 1000)
		{
			strcpy (pPathName, pDirName);
			strcat (pPathName, fd.cFileName);

			//ȡID
			uLen = strlen (fd.cFileName);
			
			lID = 0;
			for (i = 0; i < uLen - 4; i++)
			{
				ch = fd.cFileName[i];
				if (ch < '0' || ch > '9') break;

				lID *= 10;
				lID += ch - '0';
			}
			if (i < uLen - 4 || lID >= 0x3FFF)
			{
				MessageBox ("ļ" + CString(fd.cFileName) + "Ч!");
				return;
			}
			gpIDBuf[gnFeaCnt] = (lID << 16) + gnFeaCnt;

			//ȡֵ
			if (f.Open (pPathName, CFile::modeRead) == NULL)
			{
				MessageBox ("ļʧ!");
				return;
			}
			if (f.Read (gpFeaBuf[gnFeaCnt], FEA_LEN) != FEA_LEN)
			{
				f.Close();
				MessageBox ("ļȡʧ!");
				return;
			}
			f.Close();
			gnFeaCnt ++;
		}
		bSearch = FindNextFile (hSearch, &fd);
		if (!bSearch) break;
	}

	sort_DWORD (gpIDBuf, gnFeaCnt);

	gnFeaIndx = 0;

	gbRegStart = true;
	UpdateData (true);
	m_nType = RADIO_FROM_VALUE_DB;
	m_nBatchCnt = gnFeaCnt;
	m_nBatchIndx = gnFeaIndx + 1;
	UpdateData (false);
	CmdRefresh();	

	gbBatch = TRUE;
	OnCmdInter();
	gnLenAck = 0;	
}

void CCommTestDlg::OnCheckEnableBatch() 
{
	UpdateData (true);
	if (m_bEnableBatch) 
	{
		m_btnBatch.EnableWindow (true);
		m_staticBatchCnt.EnableWindow (true);
		m_staticBatchIndx.EnableWindow (true);
		m_editBatchCnt.EnableWindow (true);
		m_editBatchIndx.EnableWindow (true);
	}
	else 
	{
		m_btnBatch.EnableWindow (false);
		m_staticBatchCnt.EnableWindow (false);
		m_staticBatchIndx.EnableWindow (false);
		m_editBatchCnt.EnableWindow (false);
		m_editBatchIndx.EnableWindow (false);
	}
}

void CCommTestDlg::OnCheckGetStorage() 
{
	UpdateData (true);
	m_nType = RADIO_GET_USER_SUM_DB;
	UpdateData (false);
	CmdRefresh();
}
